(import (rnrs)
	(mosh) (system)
	(rnrs eval)
	(primitives throw ex:destructive-eval! ex:current-environment sexp-map sexp-map/debug))

(define initprog
  '((import (rnrs) 
	    (mosh)
	    (system)
	    (rnrs mutable-pairs)
	    (primitives permissive-eval sexp-map sexp-map/debug) (nmosh mosh-vm))
    (define %loadpath "lib.boot:lib.rnrs:lib:../../../lib")
    (define %verbose #t)
    (define %nmosh-failproc #f)))

(define m (ex:current-environment))

(define (read-all/port p)
  (let ((r (read p)))
    (if (eof-object? r)
      '()
      (cons r (read-all/port p)))))

(define (read-all fn)
  (call-with-input-file fn read-all/port))
(define (xeval e)
  (ex:destructive-eval! e m))
(define (xload l)
  (for-each xeval l))

(define (pload fn)
  (display "loading ")
  (display fn)(newline)
  (xload (read-all fn))
  (display "done.")(newline))

(set-symbol-value! 'permissive-eval xeval)

(xload initprog)
(xeval '(define eval-core permissive-eval))
(pload "mosh-exceptions.scm")
(pload "compat-mosh-run.scm")
(pload "mosh-utils5.scm")
(pload "runtime.scm")
(xeval '(set! id-symbol '*ID-BUILD*))
(pload "expander.scm")
(pload "bootstrap.common/build-expander.scm")
(pload "layout.scm")
(pload "bootstrap.common/build-body.scm")
