;;
;;   Copyright (c) 2008  Higepon(Taro Minowa)  <higepon@users.sourceforge.jp>
;;
;;   Redistribution and use in source and binary forms, with or without
;;   modification, are permitted provided that the following conditions
;;   are met:
;;
;;   1. Redistributions of source code must retain the above copyright
;;      notice, this list of conditions and the following disclaimer.
;;
;;   2. Redistributions in binary form must reproduce the above copyright
;;      notice, this list of conditions and the following disclaimer in the
;;      documentation and/or other materials provided with the distribution.
;;
;;   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;;   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
;;   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
;;   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;;   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;;   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;
(import (rnrs)
        (mosh string)
        (srfi-1)
        (mosh hashtable)
        (mosh file))

(define (main args)
  (format #t ";; Do not edit this file which generated by ~a.\n;;\n" (first args))
  (display "(define combination-class-list '(")
  (let ([hashtable (make-eq-hashtable)])
    (let loop ([lines (file->list "data/UnicodeData.txt")])
      (cond [(null? lines) '()]
            [(#/^[0-9A-F]+\;[^\;]*\;[^\;]*\;0\;[^\;]*\;/ (car lines))
             (loop (cdr lines))]
            [(#/^([0-9A-F]+)\;[^\;]*\;[^\;]*\;([^\;]+)\;[^\;]*\;/ (car lines))
             => (lambda (m)
                  (hashtable-set! hashtable (string->number (m 2)) (append (hashtable-ref hashtable (string->number (m 2)) '())
                                                                               (list (string->number (m 1) 16))))
                  (loop (cdr lines)))]
            [else (loop (cdr lines))]))
    (hashtable-for-each
     (lambda (key value)
       (format #t "(~a . ~a)\n" key value))
     hashtable))
    (display "))")
    (newline)
    )

  (main (command-line))
