/*
 * TestingVM.h - 
 *
 *   Copyright (c) 2008  Higepon(Taro Minowa)  <higepon@users.sourceforge.jp>
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Id: TestingVM.h 261 2008-07-25 06:16:44Z higepon $
 */

#ifndef SCHEME_TESTING_VM_
#define SCHEME_TESTING_VM_

#include "scheme.h"
#include "VM.h"

namespace scheme {

class TestingVM : public VM
{
public:
    enum FlushType {
        NONE,
        FLUSH_BINARY_OUTPUT_PORT,
        FLUSH_BINARY_INPUT_OUTPUT_PORT,
        FLUSH_TEXTUAL_OUTPUT_PORT,
        FLUSH_TEXTUAL_INPUT_OUTPUT_PORT,
    };

    TestingVM(int stackSize, Object outPort, Object errorPort, Object inputPort, bool isProfiler = false) :
        VM(stackSize, outPort, errorPort, inputPort, isProfiler), lastFlushType_(NONE)
    {
    }

    virtual ~TestingVM()
    {
    }

    virtual int exit(int status);
    virtual void flushAllPorts();

    FlushType lastFlushType_;
};

} // namespace scheme

#endif // SCHEME_TESTINGVM_
