/* Generated by re2c 0.13.5 on Mon Nov  1 21:23:43 2010 */
#line 1 "src/scanner.re"
/*
 * scanner.re
 *
 *   Copyright (c) 2008  Higepon(Taro Minowa)  <higepon@users.sourceforge.jp>
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Id: Reader.y 183 2008-07-04 06:19:28Z higepon $
 */
#include <stdio.h>
#include "Object.h"
#include "Pair.h"
#include "StringProcedures.h"
#include "TextualInputPort.h"
#include "TextualOutputPort.h"
#include "EqHashTable.h"
#include "ucs4string.h"
#include "ScannerHelper.h"
#include "Scanner.h"
#include "OSCompatThread.h"
#include "VM.h"
#include "MultiVMProcedures.h"

#define YYCTYPE ucs4char
#define YYCURSOR cursor_
#define YYMARKER marker_
#define YYLIMIT limit_
#define YYTOKEN token_
#define YYDEBUG(state, ch)  yydebug(state, ch)
#define YYFILL(n) fill(n)

using namespace scheme;

Scanner::Scanner() : eofP_(false),
                     buffer_(NULL),
                     cursor_(buffer_),
                     token_(buffer_),
                     limit_(buffer_),
                     marker_(buffer_),
                     bufferSize_(32)
{
}

Scanner::~Scanner()
{
}

// Since re2c greedy look-aheads,
// we need to give back read buffer to input-port.
void Scanner::emptyBuffer()
{
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();

    for (ucs4char* p = limit_ - 1; p >= cursor_; p--) {
        // special case
        if (eofP_ && p == limit_ - 1 && *p == '\0') {
            continue;
        } else {
            inputPort->unGetChar(*p);
        }
    }

    // even if port reaches EOF, we turns off this flag.
    // fill() will detect EOF.
    eofP_ = false;
    cursor_ = buffer_;
    limit_ = buffer_;
    token_ = buffer_;
    marker_ = buffer_;
}

void Scanner::fill(int n)
{
    if (eofP_) return;
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();
    const int restCharCount = limit_ - token_;
    const int tokenOffset = token_ - buffer_;

    if (buffer_ == NULL) {
        buffer_ = new(GC) ucs4char[bufferSize_];
        cursor_ = buffer_;
        limit_ = buffer_;
        token_ = buffer_;
        marker_ = buffer_;
    }

    if ((restCharCount + n) > bufferSize_) {
        ucs4char* newBuffer = new(GC) ucs4char[restCharCount + n + 1];
        bufferSize_ = restCharCount + n + 1;
        memmove(newBuffer, token_, restCharCount * sizeof(ucs4char));
        cursor_ = &newBuffer[cursor_ - buffer_];
        token_ = &newBuffer[token_ - buffer_];
        limit_ = &newBuffer[limit_ - buffer_];
        marker_ = &newBuffer[marker_ - buffer_];
        buffer_ = newBuffer;
    } else if (restCharCount > 0) {
        memmove(buffer_, token_, restCharCount * sizeof(ucs4char));
    }

    int i;
    for (i = 0; i < n; i++) {
        const ucs4char ch = inputPort->getChar();
        if (ch == EOF) {
            eofP_ = true;
            buffer_[i + restCharCount] = '\0';
            i++;
            break;
        } else {
            buffer_[i + restCharCount] = ch;
        }
//         if (!inputPort->isDataReady()) {
//             i++;
//
//             break;
//         }

    }
    const int readSize = i;
    cursor_ = cursor_ - tokenOffset;
    token_ = buffer_;
    marker_ = marker_ - tokenOffset;
    limit_ = limit_ - tokenOffset + readSize;
}

int yylex(YYSTYPE* yylval)
{
    return currentVM()->readerContext()->port()->scanner()->scan(yylval);
}

int Scanner::scan(YYSTYPE* yylval)
{
#line 228 "src/scanner.re"


    int comment_count = 0;

    for(;;)
    {

#line 164 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	if ((YYLIMIT - YYCURSOR) < 18) YYFILL(18);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy23;
					if (yych <= 0x00000008) goto yy25;
					goto yy22;
				} else {
					if (yych <= 0x0000001F) goto yy25;
					if (yych <= ' ') goto yy22;
					goto yy9;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '"') goto yy13;
					if (yych >= '$') goto yy9;
				} else {
					if (yych <= '\'') goto yy15;
					if (yych <= '(') goto yy20;
					if (yych <= ')') goto yy18;
					goto yy9;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= '+') goto yy4;
					if (yych <= ',') goto yy16;
					goto yy5;
				} else {
					if (yych <= '.') goto yy7;
					if (yych <= '/') goto yy9;
					goto yy6;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy17;
					goto yy9;
				} else {
					if (yych <= '@') goto yy8;
					if (yych <= 'Z') goto yy9;
					if (yych <= '[') goto yy20;
					goto yy12;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '`') {
					if (yych <= ']') goto yy18;
					if (yych <= '_') goto yy9;
					goto yy14;
				} else {
					if (yych <= 'z') goto yy9;
					if (yych <= '}') goto yy25;
					goto yy9;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy25;
					if (yych <= 0x00000084) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x000000A0) goto yy10;
					if (yych <= 0x0000167F) goto yy9;
					goto yy10;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy10;
					goto yy9;
				} else {
					if (yych <= 0x0000200A) goto yy10;
					if (yych <= 0x00002027) goto yy9;
					if (yych <= 0x00002029) goto yy10;
					goto yy9;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy10;
					if (yych <= 0x0000205E) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x00003000) goto yy10;
					if (yych <= 0x0000FFFF) goto yy9;
					goto yy25;
				}
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '!':	goto yy342;
	case '\'':	goto yy345;
	case '(':	goto yy340;
	case ',':	goto yy343;
	case '/':	goto yy346;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy355;
	case ';':	goto yy337;
	case 'B':
	case 'b':	goto yy352;
	case 'D':
	case 'd':	goto yy351;
	case 'E':
	case 'I':
	case 'e':
	case 'i':	goto yy349;
	case 'F':
	case 'f':	goto yy354;
	case 'O':
	case 'o':	goto yy350;
	case 'T':
	case 't':	goto yy357;
	case 'X':
	case 'x':	goto yy348;
	case '\\':	goto yy353;
	case '`':	goto yy344;
	case 'v':	goto yy339;
	case '|':	goto yy335;
	default:	goto yy3;
	}
yy3:
#line 479 "src/scanner.re"
	{
            // syntax error
            return 0;
        }
#line 311 "<stdout>"
yy4:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy67;
					goto yy3;
				} else {
					if (yych <= '\r') goto yy67;
					if (yych <= 0x0000001F) goto yy3;
					goto yy67;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy3;
					goto yy67;
				} else {
					if (yych <= '\'') goto yy3;
					if (yych <= ')') goto yy67;
					goto yy3;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy299;
					goto yy3;
				} else {
					if (yych <= '9') goto yy302;
					if (yych <= ':') goto yy3;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych == '[') goto yy67;
					goto yy3;
				} else {
					if (yych <= ']') goto yy67;
					if (yych <= 'h') goto yy3;
					goto yy300;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'n') {
					if (yych <= 'm') goto yy3;
					goto yy301;
				} else {
					if (yych == 0x00000085) goto yy67;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy67;
					goto yy3;
				} else {
					if (yych <= 0x00001680) goto yy67;
					if (yych <= 0x0000180D) goto yy3;
					goto yy67;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy3;
					goto yy67;
				} else {
					if (yych <= 0x00002027) goto yy3;
					if (yych <= 0x00002029) goto yy67;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy67;
					if (yych <= 0x0000205E) goto yy3;
					goto yy67;
				} else {
					if (yych == 0x00003000) goto yy67;
					goto yy3;
				}
			}
		}
	}
yy5:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '\r') {
				if (yych <= 0x00000000) goto yy62;
				if (yych <= 0x00000008) goto yy3;
				goto yy62;
			} else {
				if (yych <= 0x0000001F) goto yy3;
				if (yych <= '&') goto yy62;
				goto yy3;
			}
		} else {
			if (yych <= '-') {
				if (yych == ',') goto yy3;
				goto yy62;
			} else {
				if (yych <= '.') goto yy180;
				if (yych <= '/') goto yy62;
				if (yych <= '9') goto yy181;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'm') {
			if (yych <= '`') {
				if (yych <= '>') goto yy178;
				if (yych <= '_') goto yy62;
				goto yy3;
			} else {
				if (yych == 'i') goto yy183;
				goto yy62;
			}
		} else {
			if (yych <= '}') {
				if (yych <= 'n') goto yy184;
				if (yych <= 'z') goto yy62;
				goto yy3;
			} else {
				if (yych == 0x0000007F) goto yy3;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy3;
			}
		}
	}
yy6:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '\\') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy160;
					if (yych <= 0x00000008) goto yy3;
					goto yy160;
				} else {
					if (yych == ' ') goto yy160;
					goto yy3;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy160;
					if (yych <= '\'') goto yy3;
					goto yy160;
				} else {
					if (yych == '+') goto yy160;
					if (yych <= ',') goto yy3;
					goto yy160;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= '?') {
					if (yych == ';') goto yy160;
					goto yy3;
				} else {
					if (yych <= '@') goto yy160;
					if (yych <= 'C') goto yy3;
					goto yy160;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy160;
					goto yy3;
				} else {
					if (yych <= 'S') goto yy160;
					if (yych == '[') goto yy160;
					goto yy3;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 'r') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy160;
					if (yych <= 'c') goto yy3;
					goto yy160;
				} else {
					if (yych == 'l') goto yy160;
					goto yy3;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 's') goto yy160;
					if (yych <= 0x00000084) goto yy3;
					goto yy160;
				} else {
					if (yych == 0x000000A0) goto yy160;
					if (yych <= 0x0000167F) goto yy3;
					goto yy160;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy160;
					goto yy3;
				} else {
					if (yych <= 0x0000200A) goto yy160;
					if (yych <= 0x00002027) goto yy3;
					goto yy160;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy160;
					goto yy3;
				} else {
					if (yych <= 0x0000205F) goto yy160;
					if (yych == 0x00003000) goto yy160;
					goto yy3;
				}
			}
		}
	}
yy7:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy71;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy71;
				goto yy3;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy71;
					goto yy3;
				} else {
					if (yych <= '#') goto yy71;
					if (yych <= '\'') goto yy3;
					goto yy71;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy3;
					goto yy73;
				} else {
					if (yych <= '/') goto yy3;
					if (yych <= '9') goto yy74;
					goto yy3;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy71;
					goto yy3;
				} else {
					if (yych == '\\') goto yy3;
					goto yy71;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy71;
				if (yych <= 0x0000009F) goto yy3;
				goto yy71;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy3;
					goto yy71;
				} else {
					if (yych == 0x0000180E) goto yy71;
					goto yy3;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy71;
					goto yy3;
				} else {
					if (yych <= 0x00002029) goto yy71;
					if (yych <= 0x0000202E) goto yy3;
					goto yy71;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy71;
				} else {
					if (yych == 0x00003000) goto yy71;
					goto yy3;
				}
			}
		}
	}
yy8:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy67;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy67;
				goto yy3;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy67;
					goto yy3;
				} else {
					if (yych <= '#') goto yy67;
					if (yych <= '\'') goto yy3;
					goto yy67;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy67;
				if (yych <= ':') goto yy3;
				goto yy67;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy3;
					goto yy67;
				} else {
					if (yych == ']') goto yy67;
					goto yy3;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy67;
				if (yych == 0x000000A0) goto yy67;
				goto yy3;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy67;
					goto yy3;
				} else {
					if (yych <= 0x0000180E) goto yy67;
					if (yych <= 0x00001FFF) goto yy3;
					goto yy67;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy3;
				if (yych <= 0x00002029) goto yy67;
				if (yych <= 0x0000202E) goto yy3;
				goto yy67;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy67;
				} else {
					if (yych == 0x00003000) goto yy67;
					goto yy3;
				}
			}
		}
	}
yy9:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy3;
			if (yych <= '\r') goto yy62;
			goto yy3;
		} else {
			if (yych == '\'') goto yy3;
			if (yych <= '+') goto yy62;
			goto yy3;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy3;
			if (yych <= 'z') goto yy62;
			goto yy3;
		} else {
			if (yych == 0x0000007F) goto yy3;
			if (yych <= 0x0000FFFF) goto yy62;
			goto yy3;
		}
	}
yy10:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy11;
			if (yych <= '\r') goto yy62;
		} else {
			if (yych == '\'') goto yy11;
			if (yych <= '+') goto yy62;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy11;
			if (yych <= 'z') goto yy62;
		} else {
			if (yych == 0x0000007F) goto yy11;
			if (yych <= 0x0000FFFF) goto yy62;
		}
	}
yy11:
#line 463 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 731 "<stdout>"
yy12:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'x') goto yy58;
	goto yy3;
yy13:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy44;
yy14:
	yych = *++YYCURSOR;
	goto yy41;
yy15:
	yych = *++YYCURSOR;
	goto yy39;
yy16:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy36;
	goto yy34;
yy17:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy27;
yy18:
	++YYCURSOR;
#line 445 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return RIGHT_PAREN;
        }
#line 763 "<stdout>"
yy20:
	++YYCURSOR;
#line 450 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return LEFT_PAREN;
        }
#line 772 "<stdout>"
yy22:
	yych = *++YYCURSOR;
	goto yy11;
yy23:
	++YYCURSOR;
#line 467 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return END_OF_FILE;
        }
#line 783 "<stdout>"
yy25:
	yych = *++YYCURSOR;
	goto yy3;
yy26:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy27:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy28:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy30:
#line 441 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 838 "<stdout>"
yy31:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych >= 0x00000001) goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy33:
	yych = *++YYCURSOR;
	goto yy30;
yy34:
	++YYCURSOR;
#line 419 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTE; }
#line 871 "<stdout>"
yy36:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 414 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTESPLICING;
        }
#line 881 "<stdout>"
yy39:
	++YYCURSOR;
#line 409 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUOTE;
        }
#line 890 "<stdout>"
yy41:
	++YYCURSOR;
#line 404 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASIQUOTE;
        }
#line 899 "<stdout>"
yy43:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy44:
	if (yych == '"') goto yy47;
	if (yych != '\\') goto yy43;
yy45:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'u') {
		if (yych <= '\\') {
			if (yych <= '\r') {
				if (yych <= '\t') {
					if (yych >= '\t') goto yy51;
				} else {
					if (yych <= '\n') goto yy53;
					if (yych >= '\r') goto yy55;
				}
			} else {
				if (yych <= '!') {
					if (yych == ' ') goto yy51;
				} else {
					if (yych <= '"') goto yy43;
					if (yych >= '\\') goto yy43;
				}
			}
		} else {
			if (yych <= 'm') {
				if (yych <= 'b') {
					if (yych >= 'a') goto yy43;
				} else {
					if (yych == 'f') goto yy43;
				}
			} else {
				if (yych <= 'r') {
					if (yych <= 'n') goto yy43;
					if (yych >= 'r') goto yy43;
				} else {
					if (yych == 't') goto yy43;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'w') {
					if (yych <= 'v') goto yy43;
				} else {
					if (yych <= 'x') goto yy50;
					if (yych >= 0x00000085) goto yy53;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy51;
				} else {
					if (yych <= 0x00001680) goto yy51;
					if (yych >= 0x0000180E) goto yy51;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych >= 0x00002000) goto yy51;
				} else {
					if (yych == 0x00002028) goto yy53;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy51;
					if (yych >= 0x0000205F) goto yy51;
				} else {
					if (yych == 0x00003000) goto yy51;
				}
			}
		}
	}
yy46:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 4) {
		if (yyaccept <= 2) {
			if (yyaccept <= 1) {
				if (yyaccept <= 0) {
					goto yy3;
				} else {
					goto yy11;
				}
			} else {
				goto yy30;
			}
		} else {
			if (yyaccept <= 3) {
				goto yy65;
			} else {
				goto yy72;
			}
		}
	} else {
		if (yyaccept <= 6) {
			if (yyaccept <= 5) {
				goto yy78;
			} else {
				goto yy587;
			}
		} else {
			if (yyaccept <= 7) {
				goto yy750;
			} else {
				goto yy770;
			}
		}
	}
yy47:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy48;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy48;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy48;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy48;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy48;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy48;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy48:
	++YYCURSOR;
#line 392 "src/scanner.re"
	{

            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN) - 2);
            YYTOKEN = YYCURSOR;
            return STRING;
        }
#line 1078 "<stdout>"
yy50:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy56;
		goto yy46;
	} else {
		if (yych <= 'F') goto yy56;
		if (yych <= '`') goto yy46;
		if (yych <= 'f') goto yy56;
		goto yy46;
	}
yy51:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00001680) {
		if (yych <= 0x0000001F) {
			if (yych <= '\n') {
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\t') goto yy51;
			} else {
				if (yych == '\r') goto yy55;
				goto yy46;
			}
		} else {
			if (yych <= 0x00000085) {
				if (yych <= ' ') goto yy51;
				if (yych <= 0x00000084) goto yy46;
			} else {
				if (yych == 0x000000A0) goto yy51;
				if (yych <= 0x0000167F) goto yy46;
				goto yy51;
			}
		}
	} else {
		if (yych <= 0x00002028) {
			if (yych <= 0x00001FFF) {
				if (yych == 0x0000180E) goto yy51;
				goto yy46;
			} else {
				if (yych <= 0x0000200A) goto yy51;
				if (yych <= 0x00002027) goto yy46;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy51;
				goto yy46;
			} else {
				if (yych <= 0x0000205F) goto yy51;
				if (yych == 0x00003000) goto yy51;
				goto yy46;
			}
		}
	}
yy53:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x0000167F) {
		if (yych <= '!') {
			if (yych <= '\t') {
				if (yych <= 0x00000008) goto yy43;
				goto yy53;
			} else {
				if (yych == ' ') goto yy53;
				goto yy43;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '"') goto yy47;
				if (yych <= '[') goto yy43;
				goto yy45;
			} else {
				if (yych == 0x000000A0) goto yy53;
				goto yy43;
			}
		}
	} else {
		if (yych <= 0x0000202E) {
			if (yych <= 0x0000180E) {
				if (yych <= 0x00001680) goto yy53;
				if (yych <= 0x0000180D) goto yy43;
				goto yy53;
			} else {
				if (yych <= 0x00001FFF) goto yy43;
				if (yych <= 0x0000200A) goto yy53;
				goto yy43;
			}
		} else {
			if (yych <= 0x0000205F) {
				if (yych <= 0x0000202F) goto yy53;
				if (yych <= 0x0000205E) goto yy43;
				goto yy53;
			} else {
				if (yych == 0x00003000) goto yy53;
				goto yy43;
			}
		}
	}
yy55:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x000000A0) {
		if (yych <= '"') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000008) goto yy43;
				if (yych <= '\n') goto yy53;
				goto yy43;
			} else {
				if (yych <= ' ') goto yy53;
				if (yych <= '!') goto yy43;
				goto yy47;
			}
		} else {
			if (yych <= 0x00000084) {
				if (yych == '\\') goto yy45;
				goto yy43;
			} else {
				if (yych <= 0x00000085) goto yy53;
				if (yych <= 0x0000009F) goto yy43;
				goto yy53;
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000180D) {
				if (yych == 0x00001680) goto yy53;
				goto yy43;
			} else {
				if (yych <= 0x0000180E) goto yy53;
				if (yych <= 0x00001FFF) goto yy43;
				goto yy53;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy53;
				goto yy43;
			} else {
				if (yych <= 0x0000205F) goto yy53;
				if (yych == 0x00003000) goto yy53;
				goto yy43;
			}
		}
	}
yy56:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy56;
		if (yych <= ':') goto yy46;
		goto yy43;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy56;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy56;
			goto yy46;
		}
	}
yy58:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy46;
	goto yy60;
yy59:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy60:
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy59;
		if (yych <= ':') goto yy46;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy59;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy59;
			goto yy46;
		}
	}
yy61:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy62:
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy67;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy67;
					if (yych <= 0x0000001F) goto yy46;
					goto yy67;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy61;
					if (yych <= '#') goto yy67;
					goto yy61;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy67;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy61;
				} else {
					if (yych == ';') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy66;
					goto yy67;
				} else {
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych != 0x000000A0) goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy63;
					if (yych <= 0x0000180D) goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych >= 0x0000200B) goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy63;
					if (yych <= 0x0000202E) goto yy61;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych != 0x0000205F) goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy63:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy67;
				} else {
					if (yych <= '\r') goto yy67;
					if (yych >= ' ') goto yy67;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy61;
					if (yych <= '#') goto yy67;
					goto yy61;
				} else {
					if (yych <= '\'') goto yy65;
					if (yych <= ')') goto yy67;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy65;
					if (yych <= '-') goto yy61;
					goto yy63;
				} else {
					if (yych == ';') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy66;
					goto yy67;
				} else {
					if (yych != '`') goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych >= '~') goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy65;
					if (yych <= 0x00000084) goto yy61;
					goto yy63;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy63;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy63;
					if (yych <= 0x0000180D) goto yy61;
					goto yy63;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy63;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy63;
					if (yych <= 0x0000202E) goto yy61;
					goto yy63;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy63;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
				}
			}
		}
	}
yy65:
#line 380 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
            YYTOKEN = YYCURSOR;
            return IDENTIFIER;
            }
#line 1447 "<stdout>"
yy66:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == 'x') goto yy68;
	goto yy46;
yy67:
	yych = *++YYCURSOR;
	goto yy65;
yy68:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy69;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy69:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy69;
		if (yych <= ':') goto yy46;
		goto yy61;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy69;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy69;
			goto yy46;
		}
	}
yy71:
	++YYCURSOR;
yy72:
#line 399 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return DOT;
        }
#line 1497 "<stdout>"
yy73:
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '.') goto yy157;
	goto yy72;
yy74:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '+') goto yy80;
					if (yych <= ',') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy74;
				} else {
					if (yych == ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				} else {
					if (yych <= 'L') goto yy76;
					if (yych != 'S') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy76;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy76:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy154;
		goto yy46;
	} else {
		if (yych <= '-') goto yy154;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy155;
		goto yy46;
	}
yy77:
	++YYCURSOR;
yy78:
#line 362 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 1615 "<stdout>"
yy79:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy118;
		if (yych <= ',') goto yy46;
		goto yy118;
	} else {
		if (yych <= '.') goto yy121;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy119;
		goto yy46;
	}
yy80:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy85;
		if (yych <= '/') goto yy46;
		goto yy83;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
		} else {
			if (yych == 'n') goto yy82;
			goto yy46;
		}
	}
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 'm') goto yy46;
					goto yy115;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy82:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy111;
	goto yy46;
yy83:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'R') {
		if (yych <= '9') {
			if (yych <= '-') goto yy46;
			if (yych <= '.') goto yy93;
			if (yych <= '/') goto yy95;
			goto yy83;
		} else {
			if (yych <= 'F') {
				if (yych <= 'C') goto yy46;
				goto yy94;
			} else {
				if (yych == 'L') goto yy94;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') {
				if (yych <= 'S') goto yy94;
				goto yy46;
			} else {
				if (yych <= 'f') goto yy94;
				if (yych <= 'h') goto yy46;
				goto yy89;
			}
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
				goto yy94;
			} else {
				if (yych == 's') goto yy94;
				goto yy46;
			}
		}
	}
yy85:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy86:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy86;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych == 'L') goto yy88;
			if (yych <= 'R') goto yy46;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy88;
			if (yych <= 'h') goto yy46;
			goto yy89;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
			} else {
				if (yych != 's') goto yy46;
			}
		}
	}
yy88:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy90;
		goto yy46;
	} else {
		if (yych <= '-') goto yy90;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy91;
		goto yy46;
	}
yy89:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy77;
				if (yych <= ':') goto yy46;
				goto yy77;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy90:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy91:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy91;
	if (yych == 'i') goto yy89;
	goto yy46;
yy93:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy102;
			if (yych <= 'F') goto yy103;
			goto yy102;
		} else {
			if (yych <= 'L') goto yy103;
			if (yych <= 'R') goto yy102;
			goto yy103;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy102;
			if (yych <= 'f') goto yy103;
			goto yy102;
		} else {
			if (yych <= 'l') goto yy103;
			if (yych == 's') goto yy103;
			goto yy102;
		}
	}
yy94:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy98;
		goto yy46;
	} else {
		if (yych <= '-') goto yy98;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy99;
		goto yy46;
	}
yy95:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy96:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy96;
	if (yych == 'i') goto yy89;
	goto yy46;
yy98:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy99:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy99;
	if (yych == 'i') goto yy89;
	goto yy46;
yy101:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy102:
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy101;
			if (yych <= 'C') goto yy46;
			goto yy107;
		} else {
			if (yych == 'L') goto yy107;
			if (yych <= 'R') goto yy46;
			goto yy107;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy107;
			if (yych <= 'h') goto yy46;
			goto yy89;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
				goto yy107;
			} else {
				if (yych == 's') goto yy107;
				goto yy46;
			}
		}
	}
yy103:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy104;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy105;
		goto yy46;
	}
yy104:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy105:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy105;
	if (yych == 'i') goto yy89;
	goto yy46;
yy107:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy108;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy109;
		goto yy46;
	}
yy108:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy109:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy109;
	if (yych == 'i') goto yy89;
	goto yy46;
yy111:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy114:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy89;
	goto yy46;
yy115:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy114;
	goto yy46;
yy118:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy121;
		if (yych <= '/') goto yy46;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy147;
		} else {
			if (yych == 'n') goto yy146;
			goto yy46;
		}
	}
yy119:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy128;
					goto yy130;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy119;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy129;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy129;
					if (yych <= 'R') goto yy46;
					goto yy129;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy129;
					goto yy46;
				} else {
					if (yych <= 'l') goto yy129;
					if (yych <= 'r') goto yy46;
					goto yy129;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy121:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy122:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy122;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy124;
					if (yych <= 'R') goto yy46;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych >= 'g') goto yy46;
				} else {
					if (yych <= 'l') goto yy124;
					if (yych <= 'r') goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy124:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy125;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy126;
		goto yy46;
	}
yy125:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy126:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy126;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy128:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy78;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy78;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy78;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					goto yy78;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy136;
					if (yych <= ':') goto yy78;
					goto yy77;
				} else {
					if (yych <= 'C') goto yy78;
					if (yych <= 'F') goto yy138;
					goto yy78;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy138;
					if (yych <= 'R') goto yy78;
					goto yy138;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy78;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy78;
					if (yych <= 'f') goto yy138;
					goto yy78;
				} else {
					if (yych <= 'l') goto yy138;
					if (yych <= 'r') goto yy78;
					goto yy138;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy78;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy78;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy78;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy78;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy78;
				}
			}
		}
	}
yy129:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy133;
		goto yy46;
	} else {
		if (yych <= '-') goto yy133;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy134;
		goto yy46;
	}
yy130:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy131:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy131;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy133:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy134:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy134;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy136:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy136;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy142;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy142;
					if (yych <= 'R') goto yy46;
					goto yy142;
				} else {
					if (yych == '[') goto yy77;
					if (yych <= '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy142;
					goto yy46;
				} else {
					if (yych <= 'l') goto yy142;
					if (yych <= 'r') goto yy46;
					goto yy142;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy138:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy139;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy140;
		goto yy46;
	}
yy139:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy140:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy140;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy142:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy143;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy144;
		goto yy46;
	}
yy143:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy144:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy144;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy146:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy151;
	goto yy46;
yy147:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy89;
	goto yy46;
yy151:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy89;
	goto yy46;
yy154:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy155:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy155;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy157:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy67;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy67;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy67;
					goto yy46;
				} else {
					if (yych <= '#') goto yy67;
					if (yych <= '\'') goto yy46;
					goto yy67;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy67;
				if (yych <= ':') goto yy46;
				goto yy67;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy67;
				} else {
					if (yych == ']') goto yy67;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy67;
				if (yych == 0x000000A0) goto yy67;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy67;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy67;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy67;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy67;
				if (yych <= 0x0000202E) goto yy46;
				goto yy67;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy67;
				} else {
					if (yych == 0x00003000) goto yy67;
					goto yy46;
				}
			}
		}
	}
yy158:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy169;
					if (yych <= 0x00000008) goto yy78;
					goto yy169;
				} else {
					if (yych == ' ') goto yy169;
					goto yy78;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy169;
					if (yych <= '\'') goto yy78;
					goto yy169;
				} else {
					if (yych == '+') goto yy169;
					if (yych <= ',') goto yy78;
					goto yy169;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy78;
					if (yych <= '9') goto yy169;
					goto yy78;
				} else {
					if (yych <= ';') goto yy169;
					if (yych == '@') goto yy169;
					goto yy78;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy170;
					if (yych <= 'K') goto yy78;
					goto yy170;
				} else {
					if (yych == 'S') goto yy170;
					if (yych <= 'Z') goto yy78;
					goto yy169;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'c') {
					if (yych == ']') goto yy169;
					goto yy78;
				} else {
					if (yych <= 'f') goto yy170;
					if (yych <= 'k') goto yy78;
					goto yy170;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy170;
					goto yy78;
				} else {
					if (yych <= 0x00000085) goto yy169;
					if (yych == 0x000000A0) goto yy169;
					goto yy78;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy169;
					if (yych <= 0x0000180D) goto yy78;
					goto yy169;
				} else {
					if (yych <= 0x00001FFF) goto yy78;
					if (yych <= 0x0000200A) goto yy169;
					if (yych <= 0x00002027) goto yy78;
					goto yy169;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy169;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy169;
					if (yych == 0x00003000) goto yy169;
					goto yy78;
				}
			}
		}
	}
yy159:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
yy160:
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '+') goto yy80;
					if (yych <= ',') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy158;
					if (yych <= '/') goto yy162;
					goto yy159;
				} else {
					if (yych == ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				} else {
					if (yych <= 'L') goto yy161;
					if (yych != 'S') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy161;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy161:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy165;
		goto yy46;
	} else {
		if (yych <= '-') goto yy165;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy166;
		goto yy46;
	}
yy162:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy163:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy163;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy165:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy166:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy166;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy168:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy169:
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '+') goto yy80;
					if (yych <= ',') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy168;
				} else {
					if (yych == ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy174;
					goto yy46;
				} else {
					if (yych <= 'L') goto yy174;
					if (yych == 'S') goto yy174;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy77;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy174;
					if (yych <= 'k') goto yy46;
					goto yy174;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy174;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy170:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy171;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy172;
		goto yy46;
	}
yy171:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy172:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy172;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy174:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy175;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy176;
		goto yy46;
	}
yy175:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy176:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy176;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy178:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy67;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy67;
					if (yych <= 0x0000001F) goto yy46;
					goto yy67;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy178;
					if (yych <= '#') goto yy67;
					goto yy178;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy67;
					goto yy178;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy178;
					goto yy293;
				} else {
					if (yych == ';') goto yy67;
					goto yy178;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy295;
					goto yy67;
				} else {
					if (yych == '`') goto yy46;
					goto yy178;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy46;
					goto yy178;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy178;
					goto yy293;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00001680) goto yy293;
					if (yych <= 0x0000180D) goto yy178;
					goto yy293;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy178;
					if (yych <= 0x0000200A) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00002029) goto yy293;
					if (yych <= 0x0000202E) goto yy178;
					goto yy293;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00003000) goto yy293;
					if (yych <= 0x0000FFFF) goto yy178;
					goto yy46;
				}
			}
		}
	}
yy180:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy287;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy181:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 10) YYFILL(10);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy189;
					goto yy46;
				} else {
					if (yych == '!') goto yy61;
					if (yych <= '#') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					goto yy192;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy269;
					goto yy271;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy181;
					if (yych == ';') goto yy189;
					goto yy61;
				} else {
					if (yych <= '@') goto yy191;
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy270;
					goto yy61;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy270;
					if (yych == 'S') goto yy270;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= '`') goto yy46;
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy270;
					goto yy61;
				} else {
					if (yych <= 'i') goto yy193;
					if (yych == 'l') goto yy270;
					goto yy61;
				}
			} else {
				if (yych <= '~') {
					if (yych <= 's') goto yy270;
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych == 0x00000085) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy190;
					if (yych == 0x00001680) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy190;
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy190;
					if (yych == 0x0000202F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy190;
						goto yy61;
					} else {
						if (yych <= 0x00003000) goto yy190;
						if (yych <= 0x0000FFFF) goto yy61;
						goto yy46;
					}
				}
			}
		}
	}
yy183:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy189;
				if (yych <= 0x00000008) goto yy62;
				if (yych <= '\r') goto yy189;
				goto yy62;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy189;
					goto yy62;
				} else {
					if (yych <= '#') goto yy189;
					if (yych <= '\'') goto yy62;
					goto yy189;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy62;
					goto yy190;
				} else {
					if (yych == ';') goto yy189;
					goto yy62;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy189;
					goto yy62;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= 'm') goto yy62;
					goto yy266;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy190;
				if (yych <= 0x0000009F) goto yy62;
				goto yy190;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x0000180E) goto yy190;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy190;
					goto yy62;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy62;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					goto yy62;
				}
			}
		}
	}
yy184:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy62;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy188;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy188:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych >= 0x00000001) goto yy62;
				} else {
					if (yych <= '\r') goto yy189;
					if (yych <= 0x0000001F) goto yy62;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy62;
				} else {
					if (yych <= '\'') goto yy62;
					if (yych >= '*') goto yy62;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy192;
					goto yy62;
				} else {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy62;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy189;
					if (yych <= '?') goto yy62;
					goto yy191;
				} else {
					if (yych != '[') goto yy62;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych >= '^') goto yy62;
				} else {
					if (yych <= 'i') goto yy193;
					if (yych <= 0x00000084) goto yy62;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy62;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy62;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy62;
					goto yy190;
				} else {
					if (yych <= 0x00002027) goto yy62;
					if (yych <= 0x00002029) goto yy190;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					goto yy62;
				}
			}
		}
	}
yy189:
	yych = *++YYCURSOR;
	goto yy78;
yy190:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy78;
			if (yych <= '\r') goto yy62;
			goto yy78;
		} else {
			if (yych == '\'') goto yy78;
			if (yych <= '+') goto yy62;
			goto yy78;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy78;
			if (yych <= 'z') goto yy62;
			goto yy78;
		} else {
			if (yych == 0x0000007F) goto yy78;
			if (yych <= 0x0000FFFF) goto yy62;
			goto yy78;
		}
	}
yy191:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy231;
		if (yych <= ',') goto yy62;
		goto yy231;
	} else {
		if (yych <= '.') goto yy230;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy232;
		goto yy62;
	}
yy192:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy194;
		if (yych <= '/') goto yy62;
		goto yy195;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy62;
			goto yy197;
		} else {
			if (yych == 'n') goto yy198;
			goto yy62;
		}
	}
yy193:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy189;
				if (yych <= 0x00000008) goto yy62;
				if (yych <= '\r') goto yy189;
				goto yy62;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy189;
					goto yy62;
				} else {
					if (yych <= '#') goto yy189;
					if (yych <= '\'') goto yy62;
					goto yy189;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy190;
				if (yych <= ':') goto yy62;
				goto yy189;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy62;
					goto yy189;
				} else {
					if (yych == ']') goto yy189;
					goto yy62;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy190;
				if (yych == 0x000000A0) goto yy190;
				goto yy62;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy190;
					goto yy62;
				} else {
					if (yych <= 0x0000180E) goto yy190;
					if (yych <= 0x00001FFF) goto yy62;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy62;
				if (yych <= 0x00002029) goto yy190;
				if (yych <= 0x0000202E) goto yy62;
				goto yy190;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					goto yy62;
				}
			}
		}
	}
yy194:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy224;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy195:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy67;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy61;
					if (yych <= '.') goto yy206;
					goto yy208;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy195;
					if (yych == ';') goto yy67;
					goto yy61;
				} else {
					if (yych <= 'F') goto yy207;
					if (yych == 'L') goto yy207;
					goto yy61;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy207;
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'f') goto yy207;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych == 'l') goto yy207;
					if (yych <= 'r') goto yy61;
					goto yy207;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= 'z') goto yy61;
					if (yych == '~') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy63;
					if (yych <= 0x0000180D) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy63;
					if (yych <= 0x00002027) goto yy61;
					goto yy63;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy197:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy189;
				if (yych <= 0x00000008) goto yy62;
				if (yych <= '\r') goto yy189;
				goto yy62;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy189;
					goto yy62;
				} else {
					if (yych <= '#') goto yy189;
					if (yych <= '\'') goto yy62;
					goto yy189;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy62;
					goto yy190;
				} else {
					if (yych == ';') goto yy189;
					goto yy62;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy189;
					goto yy62;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= 'm') goto yy62;
					goto yy203;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy190;
				if (yych <= 0x0000009F) goto yy62;
				goto yy190;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x0000180E) goto yy190;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy190;
					goto yy62;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy62;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy62;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					goto yy62;
				}
			}
		}
	}
yy198:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy62;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy202;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy202:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy193;
	goto yy62;
yy203:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy202;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy206:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'S') {
		if (yych <= ',') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy62;
				if (yych <= 0x00000008) goto yy65;
				if (yych <= '\r') goto yy62;
				goto yy65;
			} else {
				if (yych == '\'') goto yy65;
				if (yych <= '+') goto yy62;
				goto yy65;
			}
		} else {
			if (yych <= 'F') {
				if (yych <= '/') goto yy62;
				if (yych <= '9') goto yy214;
				if (yych <= 'C') goto yy62;
				goto yy216;
			} else {
				if (yych == 'L') goto yy216;
				if (yych <= 'R') goto yy62;
				goto yy216;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'f') {
				if (yych == '`') goto yy65;
				if (yych <= 'c') goto yy62;
				goto yy216;
			} else {
				if (yych == 'i') goto yy193;
				if (yych <= 'k') goto yy62;
				goto yy216;
			}
		} else {
			if (yych <= '}') {
				if (yych == 's') goto yy216;
				if (yych <= 'z') goto yy62;
				goto yy65;
			} else {
				if (yych == 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy207:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy211;
		goto yy62;
	} else {
		if (yych <= '-') goto yy211;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy212;
		goto yy62;
	}
yy208:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy209:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy67;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy67;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy63;
					goto yy61;
				} else {
					if (yych <= '9') goto yy209;
					if (yych <= ':') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy193;
					if (yych <= 'z') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00001680) goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy63;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy63;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy211:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy212:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy67;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy67;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy63;
					goto yy61;
				} else {
					if (yych <= '9') goto yy212;
					if (yych <= ':') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy193;
					if (yych <= 'z') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00001680) goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy63;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy63;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy214:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy67;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy214;
					if (yych == ';') goto yy67;
					goto yy61;
				} else {
					if (yych <= 'F') goto yy220;
					if (yych == 'L') goto yy220;
					goto yy61;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy220;
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'f') goto yy220;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych == 'l') goto yy220;
					if (yych <= 'r') goto yy61;
					goto yy220;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= 'z') goto yy61;
					if (yych == '~') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy63;
					if (yych <= 0x0000180D) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy63;
					if (yych <= 0x00002027) goto yy61;
					goto yy63;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy216:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy217;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy218;
		goto yy62;
	}
yy217:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy218:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy67;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy67;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy63;
					goto yy61;
				} else {
					if (yych <= '9') goto yy218;
					if (yych <= ':') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy193;
					if (yych <= 'z') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00001680) goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy63;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy63;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy220:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy221;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy222;
		goto yy62;
	}
yy221:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy222:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy67;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy67;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy63;
					goto yy61;
				} else {
					if (yych <= '9') goto yy222;
					if (yych <= ':') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy193;
					if (yych <= 'z') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00001680) goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy63;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy63;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy224:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy67;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy224;
					if (yych == ';') goto yy67;
					goto yy61;
				} else {
					if (yych <= 'F') goto yy226;
					if (yych != 'L') goto yy61;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy226;
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'f') goto yy226;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych == 'l') goto yy226;
					if (yych <= 'r') goto yy61;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= 'z') goto yy61;
					if (yych == '~') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy63;
					if (yych <= 0x0000180D) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy63;
					if (yych <= 0x00002027) goto yy61;
					goto yy63;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy226:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy227;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy228;
		goto yy62;
	}
yy227:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy228:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy67;
					if (yych <= 0x00000008) goto yy46;
					goto yy67;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy67;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy67;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy67;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy63;
					goto yy61;
				} else {
					if (yych <= '9') goto yy228;
					if (yych <= ':') goto yy61;
					goto yy67;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy67;
					goto yy66;
				} else {
					if (yych <= ']') goto yy67;
					if (yych == '`') goto yy46;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy193;
					if (yych <= 'z') goto yy61;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy63;
					if (yych <= 0x0000009F) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00001680) goto yy63;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy63;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy63;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy63;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy63;
					if (yych <= 0x0000205E) goto yy61;
					goto yy63;
				} else {
					if (yych == 0x00003000) goto yy63;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy230:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy260;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy231:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy230;
		if (yych <= '/') goto yy62;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy62;
			goto yy253;
		} else {
			if (yych == 'n') goto yy252;
			goto yy62;
		}
	}
yy232:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy61;
					if (yych >= '/') goto yy236;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= ';') {
					if (yych <= '9') goto yy232;
					if (yych <= ':') goto yy61;
					goto yy189;
				} else {
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy235;
					if (yych <= 'K') goto yy61;
					goto yy235;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy235;
					if (yych <= 'Z') goto yy61;
					goto yy189;
				} else {
					if (yych <= '\\') goto yy66;
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy235;
					goto yy61;
				} else {
					if (yych <= 'l') goto yy235;
					if (yych == 's') goto yy235;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy61;
					if (yych <= 0x0000007F) goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x00000085) goto yy190;
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy78;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy78;
					if (yych == '!') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy189;
					goto yy61;
				} else {
					if (yych <= ',') goto yy78;
					if (yych == '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= ';') {
					if (yych <= '9') goto yy242;
					if (yych <= ':') goto yy61;
					goto yy189;
				} else {
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy244;
					if (yych <= 'K') goto yy61;
					goto yy244;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy244;
					if (yych <= 'Z') goto yy61;
					goto yy189;
				} else {
					if (yych <= '\\') goto yy66;
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy78;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy244;
					goto yy61;
				} else {
					if (yych <= 'l') goto yy244;
					if (yych == 's') goto yy244;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy61;
					if (yych <= 0x0000007F) goto yy78;
					goto yy61;
				} else {
					if (yych <= 0x00000085) goto yy190;
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy78;
				}
			}
		}
	}
yy235:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy239;
		goto yy62;
	} else {
		if (yych <= '-') goto yy239;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy240;
		goto yy62;
	}
yy236:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy237:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy237;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy189;
					goto yy66;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy239:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy240:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy240;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy189;
					goto yy66;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy242:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= ';') {
					if (yych <= '9') goto yy242;
					if (yych <= ':') goto yy61;
					goto yy189;
				} else {
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy248;
					if (yych <= 'K') goto yy61;
					goto yy248;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy248;
					if (yych <= 'Z') goto yy61;
					goto yy189;
				} else {
					if (yych <= '\\') goto yy66;
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy248;
					goto yy61;
				} else {
					if (yych <= 'l') goto yy248;
					if (yych == 's') goto yy248;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy61;
					if (yych <= 0x0000007F) goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x00000085) goto yy190;
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy244:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy245;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy246;
		goto yy62;
	}
yy245:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy246:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy246;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy189;
					goto yy66;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy248:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy249;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy250;
		goto yy62;
	}
yy249:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy250:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy250;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy189;
					goto yy66;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy252:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy257;
	goto yy62;
yy253:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy62;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy193;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy257:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy193;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy260:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy61;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					goto yy61;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= ';') {
					if (yych <= '9') goto yy260;
					if (yych <= ':') goto yy61;
					goto yy189;
				} else {
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy262;
					if (yych <= 'K') goto yy61;
				}
			} else {
				if (yych <= '[') {
					if (yych == 'S') goto yy262;
					if (yych <= 'Z') goto yy61;
					goto yy189;
				} else {
					if (yych <= '\\') goto yy66;
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'z') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy61;
					if (yych >= 'g') goto yy61;
				} else {
					if (yych <= 'l') goto yy262;
					if (yych != 's') goto yy61;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '~') goto yy61;
					if (yych <= 0x0000007F) goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x00000085) goto yy190;
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				} else {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy262:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy263;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy264;
		goto yy62;
	}
yy263:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy264:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '+') goto yy61;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy264;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy61;
					if (yych <= '[') goto yy189;
					goto yy66;
				} else {
					if (yych <= ']') goto yy189;
					if (yych <= '_') goto yy61;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy190;
					if (yych <= 0x0000180D) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy190;
					if (yych <= 0x0000202E) goto yy61;
					goto yy190;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy266:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy62;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy62;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy62;
			if (yych <= 0x00000008) goto yy65;
			if (yych <= '\r') goto yy62;
			goto yy65;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy62;
				goto yy65;
			} else {
				if (yych == ',') goto yy65;
				goto yy62;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy188;
			if (yych == '`') goto yy65;
			goto yy62;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy65;
				goto yy62;
			} else {
				if (yych <= 0x0000007F) goto yy65;
				if (yych <= 0x0000FFFF) goto yy62;
				goto yy65;
			}
		}
	}
yy269:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '_') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy78;
					if (yych <= '\r') goto yy189;
					goto yy78;
				} else {
					if (yych == '!') goto yy61;
					if (yych <= '#') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					goto yy192;
				} else {
					if (yych <= ',') goto yy78;
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy277;
					if (yych == ';') goto yy189;
					goto yy61;
				} else {
					if (yych <= '@') goto yy191;
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy279;
					goto yy61;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy279;
					if (yych == 'S') goto yy279;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= '`') goto yy78;
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy279;
					goto yy61;
				} else {
					if (yych <= 'i') goto yy193;
					if (yych == 'l') goto yy279;
					goto yy61;
				}
			} else {
				if (yych <= '~') {
					if (yych <= 's') goto yy279;
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy78;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy78;
					if (yych == 0x00000085) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy190;
					if (yych == 0x00001680) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy190;
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy190;
					if (yych == 0x0000202F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy190;
						goto yy61;
					} else {
						if (yych <= 0x00003000) goto yy190;
						if (yych <= 0x0000FFFF) goto yy61;
						goto yy78;
					}
				}
			}
		}
	}
yy270:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy274;
		goto yy62;
	} else {
		if (yych <= '-') goto yy274;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy275;
		goto yy62;
	}
yy271:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy272:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					if (yych <= '+') goto yy192;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy272;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy191;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x000000A0) goto yy190;
					if (yych <= 0x0000167F) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy274:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy275:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					if (yych <= '+') goto yy192;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy275;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy191;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x000000A0) goto yy190;
					if (yych <= 0x0000167F) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy277:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy189;
					goto yy46;
				} else {
					if (yych == '!') goto yy61;
					if (yych <= '#') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					goto yy192;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy277;
					if (yych == ';') goto yy189;
					goto yy61;
				} else {
					if (yych <= '@') goto yy191;
					if (yych <= 'C') goto yy61;
					if (yych <= 'F') goto yy283;
					goto yy61;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy283;
					if (yych == 'S') goto yy283;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= '`') goto yy46;
					if (yych <= 'c') goto yy61;
					if (yych <= 'f') goto yy283;
					goto yy61;
				} else {
					if (yych <= 'i') goto yy193;
					if (yych == 'l') goto yy283;
					goto yy61;
				}
			} else {
				if (yych <= '~') {
					if (yych <= 's') goto yy283;
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych == 0x00000085) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy190;
					if (yych == 0x00001680) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy190;
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy190;
					if (yych == 0x0000202F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy190;
						goto yy61;
					} else {
						if (yych <= 0x00003000) goto yy190;
						if (yych <= 0x0000FFFF) goto yy61;
						goto yy46;
					}
				}
			}
		}
	}
yy279:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy280;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy281;
		goto yy62;
	}
yy280:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy281:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					if (yych <= '+') goto yy192;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy281;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy191;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x000000A0) goto yy190;
					if (yych <= 0x0000167F) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy283:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy284;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy285;
		goto yy62;
	}
yy284:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy285:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					if (yych <= '+') goto yy192;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy285;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy191;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x000000A0) goto yy190;
					if (yych <= 0x0000167F) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy287:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy189;
					goto yy46;
				} else {
					if (yych == '!') goto yy61;
					if (yych <= '#') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					goto yy192;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy287;
					if (yych == ';') goto yy189;
					goto yy61;
				} else {
					if (yych <= '@') goto yy191;
					if (yych <= 'C') goto yy61;
					if (yych >= 'G') goto yy61;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy289;
					if (yych != 'S') goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= '`') goto yy46;
					if (yych <= 'c') goto yy61;
					if (yych >= 'g') goto yy61;
				} else {
					if (yych <= 'i') goto yy193;
					if (yych != 'l') goto yy61;
				}
			} else {
				if (yych <= '~') {
					if (yych <= 's') goto yy289;
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych == 0x00000085) goto yy190;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy190;
					if (yych == 0x00001680) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy190;
					if (yych <= 0x00001FFF) goto yy61;
					if (yych <= 0x0000200A) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy190;
					if (yych == 0x0000202F) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy190;
						goto yy61;
					} else {
						if (yych <= 0x00003000) goto yy190;
						if (yych <= 0x0000FFFF) goto yy61;
						goto yy46;
					}
				}
			}
		}
	}
yy289:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy62;
	} else {
		if (yych <= '-') goto yy290;
		if (yych <= '/') goto yy62;
		if (yych <= '9') goto yy291;
		goto yy62;
	}
yy290:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy62;
	if (yych >= ':') goto yy62;
yy291:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy189;
					if (yych <= 0x00000008) goto yy46;
					goto yy189;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy189;
					goto yy61;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy189;
					if (yych <= '&') goto yy61;
					goto yy46;
				} else {
					if (yych <= ')') goto yy189;
					if (yych <= '*') goto yy61;
					if (yych <= '+') goto yy192;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy192;
					if (yych <= '.') goto yy190;
					goto yy61;
				} else {
					if (yych <= '9') goto yy291;
					if (yych <= ':') goto yy61;
					goto yy189;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy191;
					goto yy61;
				} else {
					if (yych == '\\') goto yy66;
					if (yych <= ']') goto yy189;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy61;
					goto yy193;
				} else {
					if (yych <= 'z') goto yy61;
					if (yych <= '}') goto yy46;
					goto yy61;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x000000A0) goto yy190;
					if (yych <= 0x0000167F) goto yy61;
					goto yy190;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy190;
					goto yy61;
				} else {
					if (yych <= 0x0000200A) goto yy190;
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy190;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy190;
					if (yych <= 0x0000205E) goto yy61;
					goto yy190;
				} else {
					if (yych == 0x00003000) goto yy190;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy46;
				}
			}
		}
	}
yy293:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy67;
					goto yy65;
				} else {
					if (yych <= '\r') goto yy67;
					if (yych <= 0x0000001F) goto yy65;
					goto yy67;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy178;
					if (yych <= '#') goto yy67;
					goto yy178;
				} else {
					if (yych <= '\'') goto yy65;
					if (yych <= ')') goto yy67;
					goto yy178;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy65;
					if (yych <= '-') goto yy178;
					goto yy293;
				} else {
					if (yych == ';') goto yy67;
					goto yy178;
				}
			} else {
				if (yych <= ']') {
					if (yych != '\\') goto yy67;
				} else {
					if (yych == '`') goto yy65;
					goto yy178;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy65;
					goto yy178;
				} else {
					if (yych <= 0x0000007F) goto yy65;
					if (yych <= 0x00000084) goto yy178;
					goto yy293;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00001680) goto yy293;
					if (yych <= 0x0000180D) goto yy178;
					goto yy293;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy178;
					if (yych <= 0x0000200A) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00002029) goto yy293;
					if (yych <= 0x0000202E) goto yy178;
					goto yy293;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy293;
					goto yy178;
				} else {
					if (yych <= 0x00003000) goto yy293;
					if (yych <= 0x0000FFFF) goto yy178;
					goto yy65;
				}
			}
		}
	}
yy295:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych != 'x') goto yy46;
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy297;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy297:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy297;
		if (yych <= ':') goto yy46;
		goto yy178;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy297;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy297;
			goto yy46;
		}
	}
yy299:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy65;
	if (yych <= '9') goto yy329;
	goto yy65;
yy300:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 'm') goto yy46;
					goto yy326;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy301:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy322;
	goto yy46;
yy302:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy306;
					if (yych <= '9') goto yy302;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy305;
					if (yych <= 'K') goto yy46;
					goto yy305;
				} else {
					if (yych == 'S') goto yy305;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy305;
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy305;
					if (yych <= 'r') goto yy46;
					goto yy305;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy313;
					if (yych <= 0x00000008) goto yy78;
					goto yy313;
				} else {
					if (yych == ' ') goto yy313;
					if (yych <= '!') goto yy78;
					goto yy313;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy313;
					goto yy78;
				} else {
					if (yych == ',') goto yy78;
					if (yych <= '.') goto yy313;
					goto yy78;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych == ':') goto yy78;
					goto yy313;
				} else {
					if (yych == '@') goto yy313;
					if (yych <= 'C') goto yy78;
					goto yy314;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy314;
					goto yy78;
				} else {
					if (yych <= 'S') goto yy314;
					if (yych == '[') goto yy313;
					goto yy78;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy313;
					if (yych <= 'c') goto yy78;
					goto yy314;
				} else {
					if (yych == 'i') goto yy313;
					if (yych <= 'k') goto yy78;
					goto yy314;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy314;
					goto yy78;
				} else {
					if (yych <= 0x00000085) goto yy313;
					if (yych == 0x000000A0) goto yy313;
					goto yy78;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy313;
					if (yych <= 0x0000180D) goto yy78;
					goto yy313;
				} else {
					if (yych <= 0x00001FFF) goto yy78;
					if (yych <= 0x0000200A) goto yy313;
					if (yych <= 0x00002027) goto yy78;
					goto yy313;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy313;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy313;
					if (yych == 0x00003000) goto yy313;
					goto yy78;
				}
			}
		}
	}
yy305:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy309;
		goto yy46;
	} else {
		if (yych <= '-') goto yy309;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy310;
		goto yy46;
	}
yy306:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy307:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy307;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy309:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy310:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy310;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy312:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy313:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy312;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy318;
					if (yych <= 'K') goto yy46;
					goto yy318;
				} else {
					if (yych == 'S') goto yy318;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy318;
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy318;
					if (yych <= 'r') goto yy46;
					goto yy318;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy314:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy315;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy316;
		goto yy46;
	}
yy315:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy316:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy316;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy318:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy319;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy320;
		goto yy46;
	}
yy319:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy320:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy320;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy322:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy325:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy89;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy326:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy325;
	goto yy46;
yy329:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy329;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy331;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy331;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy331;
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy331;
					if (yych <= 'r') goto yy46;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy331:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy332;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy333;
		goto yy46;
	}
yy332:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy333:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy333;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy89;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy335:
	++YYCURSOR;
#line 475 "src/scanner.re"
	{
            comment_count = 1;
            goto comment;
        }
#line 8523 "<stdout>"
yy337:
	++YYCURSOR;
#line 471 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return DATUM_COMMENT;
        }
#line 8531 "<stdout>"
yy339:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy777;
	goto yy46;
yy340:
	++YYCURSOR;
#line 455 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return VECTOR_START;
        }
#line 8543 "<stdout>"
yy342:
	yych = *++YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= ',') goto yy763;
		if (yych <= '9') goto yy765;
		if (yych <= '@') goto yy763;
		goto yy765;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy763;
			goto yy765;
		} else {
			if (yych <= '`') goto yy763;
			if (yych <= 'z') goto yy765;
			goto yy763;
		}
	}
yy343:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy759;
	goto yy757;
yy344:
	yych = *++YYCURSOR;
	goto yy755;
yy345:
	yych = *++YYCURSOR;
	goto yy753;
yy346:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy748;
	if (yych == '\\') goto yy746;
	goto yy346;
yy348:
	yych = *++YYCURSOR;
	if (yych <= '.') {
		if (yych <= '*') {
			if (yych == '#') goto yy745;
			goto yy46;
		} else {
			if (yych == ',') goto yy46;
			if (yych <= '-') goto yy577;
			goto yy582;
		}
	} else {
		if (yych <= '@') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy578;
			goto yy46;
		} else {
			if (yych <= 'F') goto yy580;
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy580;
			goto yy46;
		}
	}
yy349:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy575;
	case '+':
	case '-':	goto yy516;
	case '.':	goto yy517;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy159;
	default:	goto yy46;
	}
yy350:
	yych = *++YYCURSOR;
	if (yych <= '+') {
		if (yych == '#') goto yy520;
		if (yych <= '*') goto yy46;
		goto yy521;
	} else {
		if (yych <= '-') {
			if (yych <= ',') goto yy46;
			goto yy521;
		} else {
			if (yych <= '/') goto yy46;
			if (yych <= '7') goto yy522;
			goto yy46;
		}
	}
yy351:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy515;
	case '+':
	case '-':	goto yy516;
	case '.':	goto yy517;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy159;
	default:	goto yy46;
	}
yy352:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy460;
	case '+':
	case '-':	goto yy461;
	case '0':
	case '1':	goto yy462;
	default:	goto yy46;
	}
yy353:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'a':	goto yy368;
	case 'b':	goto yy369;
	case 'd':	goto yy375;
	case 'e':	goto yy376;
	case 'l':	goto yy371;
	case 'n':	goto yy367;
	case 'p':	goto yy373;
	case 'r':	goto yy374;
	case 's':	goto yy366;
	case 't':	goto yy370;
	case 'v':	goto yy372;
	case 'x':	goto yy378;
	default:	goto yy377;
	}
yy354:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy364;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy364;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy364;
					goto yy46;
				} else {
					if (yych <= '#') goto yy364;
					if (yych <= '\'') goto yy46;
					goto yy364;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy364;
				if (yych <= ':') goto yy46;
				goto yy364;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy364;
				} else {
					if (yych == ']') goto yy364;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy364;
				if (yych == 0x000000A0) goto yy364;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy364;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy364;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy364;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy364;
				if (yych <= 0x0000202E) goto yy46;
				goto yy364;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy364;
				} else {
					if (yych == 0x00003000) goto yy364;
					goto yy46;
				}
			}
		}
	}
yy355:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '/') {
		if (yych == '#') goto yy362;
		goto yy46;
	} else {
		if (yych <= '9') goto yy355;
		if (yych == '=') goto yy360;
		goto yy46;
	}
yy357:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy358;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy358;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy358;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy358;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy358;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy358;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy358:
	++YYCURSOR;
#line 246 "src/scanner.re"
	{
            yylval->boolValue = true;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8825 "<stdout>"
yy360:
	++YYCURSOR;
#line 252 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINING_SHARED;
        }
#line 8835 "<stdout>"
yy362:
	++YYCURSOR;
#line 258 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINED_SHARED;
        }
#line 8845 "<stdout>"
yy364:
	++YYCURSOR;
#line 264 "src/scanner.re"
	{
            yylval->boolValue = false;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 8855 "<stdout>"
yy366:
	yych = *++YYCURSOR;
	if (yych <= 'p') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'o') goto yy46;
					goto yy454;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy367:
	yych = *++YYCURSOR;
	if (yych <= 't') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy381;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy381;
					if (yych <= 0x0000001F) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy381;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '.') goto yy381;
					goto yy46;
				} else {
					if (yych <= ';') goto yy381;
					if (yych <= 'Z') goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy381;
				} else {
					if (yych == 'e') goto yy443;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= 'u') goto yy442;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy381;
					if (yych <= 0x0000009F) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy368:
	yych = *++YYCURSOR;
	if (yych <= 'l') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'k') goto yy46;
					goto yy436;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy369:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= '`') goto yy46;
					goto yy426;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy370:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= '`') goto yy46;
					goto yy422;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy371:
	yych = *++YYCURSOR;
	if (yych <= 'i') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'h') goto yy46;
					goto yy413;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy372:
	yych = *++YYCURSOR;
	if (yych <= 't') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 's') goto yy46;
					goto yy408;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy373:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= '`') goto yy46;
					goto yy403;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy374:
	yych = *++YYCURSOR;
	if (yych <= 'e') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'd') goto yy46;
					goto yy396;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy375:
	yych = *++YYCURSOR;
	if (yych <= 'e') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'd') goto yy46;
					goto yy389;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy376:
	yych = *++YYCURSOR;
	if (yych <= 's') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy381;
				} else {
					if (yych == ';') goto yy381;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy381;
					goto yy46;
				} else {
					if (yych <= ']') goto yy381;
					if (yych <= 'r') goto yy46;
					goto yy385;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy381;
				if (yych <= 0x0000009F) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x0000180E) goto yy381;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy381;
					if (yych <= 0x0000202E) goto yy46;
					goto yy381;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy377:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy381;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy46;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy381;
				if (yych <= ':') goto yy46;
				goto yy381;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy381;
				} else {
					if (yych == ']') goto yy381;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy381;
				if (yych == 0x000000A0) goto yy381;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy381;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy381;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy381;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy381;
				if (yych <= 0x0000202E) goto yy46;
				goto yy381;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy46;
				}
			}
		}
	}
yy378:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy381;
				if (yych <= 0x00000008) goto yy380;
				if (yych <= '\r') goto yy381;
				goto yy380;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy381;
					goto yy380;
				} else {
					if (yych <= '#') goto yy381;
					if (yych <= '\'') goto yy380;
					goto yy381;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy381;
				if (yych <= ':') goto yy380;
				goto yy381;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy380;
					goto yy381;
				} else {
					if (yych == ']') goto yy381;
					goto yy380;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy381;
				if (yych == 0x000000A0) goto yy381;
				goto yy380;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy381;
					goto yy380;
				} else {
					if (yych <= 0x0000180E) goto yy381;
					if (yych <= 0x00001FFF) goto yy380;
					goto yy381;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy380;
				if (yych <= 0x00002029) goto yy381;
				if (yych <= 0x0000202E) goto yy380;
				goto yy381;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy380;
					goto yy381;
				} else {
					if (yych == 0x00003000) goto yy381;
					goto yy380;
				}
			}
		}
	}
yy379:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy380:
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy383;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy383;
					if (yych <= 0x0000001F) goto yy46;
					goto yy383;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy383;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy383;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy383;
					goto yy46;
				} else {
					if (yych <= '9') goto yy379;
					if (yych <= ':') goto yy46;
					goto yy383;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy379;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy383;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy379;
				} else {
					if (yych == 0x00000085) goto yy383;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy383;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy383;
					if (yych <= 0x0000180D) goto yy46;
					goto yy383;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy383;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy383;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy383;
					if (yych <= 0x0000205E) goto yy46;
					goto yy383;
				} else {
					if (yych == 0x00003000) goto yy383;
					goto yy46;
				}
			}
		}
	}
yy381:
	++YYCURSOR;
#line 342 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[2];
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9922 "<stdout>"
yy383:
	++YYCURSOR;
#line 348 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->charValue = ScannerHelper::hexStringToUCS4Char(YYTOKEN + 3, YYCURSOR );
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9932 "<stdout>"
yy385:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy387;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy387;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy387;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy387;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy387;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy387;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy387:
	++YYCURSOR;
#line 336 "src/scanner.re"
	{
            yylval->charValue = 0x1B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 9999 "<stdout>"
yy389:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy394;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy394;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy394;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy394;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy394;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy394;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy394:
	++YYCURSOR;
#line 330 "src/scanner.re"
	{
            yylval->charValue = 0x7F;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10072 "<stdout>"
yy396:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy401;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy401;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy401;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy401;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy401;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy401;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy401:
	++YYCURSOR;
#line 324 "src/scanner.re"
	{
            yylval->charValue = 0x0D;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10145 "<stdout>"
yy403:
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy406;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy406;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy406;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy406;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy406;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy406;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy406:
	++YYCURSOR;
#line 318 "src/scanner.re"
	{
            yylval->charValue = 0x0C;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10214 "<stdout>"
yy408:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy411;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy411;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy411;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy411;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy411;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy411;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy411:
	++YYCURSOR;
#line 312 "src/scanner.re"
	{
            yylval->charValue = 0x0B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10283 "<stdout>"
yy413:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'd') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy420;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy420;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy420;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy420;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy420;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy420;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy420:
	++YYCURSOR;
#line 306 "src/scanner.re"
	{
            yylval->charValue = 0x0A;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10360 "<stdout>"
yy422:
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy424;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy424;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy424;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy424;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy424;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy424;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy424:
	++YYCURSOR;
#line 300 "src/scanner.re"
	{
            yylval->charValue = 0x09;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10427 "<stdout>"
yy426:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'k') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 's') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy434;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy434;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy434;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy434;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy434;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy434;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy434:
	++YYCURSOR;
#line 294 "src/scanner.re"
	{
            yylval->charValue = 0x08;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10506 "<stdout>"
yy436:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy440;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy440;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy440;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy440;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy440;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy440;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy440:
	++YYCURSOR;
#line 288 "src/scanner.re"
	{
            yylval->charValue = 0x07;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10577 "<stdout>"
yy442:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy451;
	goto yy46;
yy443:
	yych = *++YYCURSOR;
	if (yych != 'w') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy449;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy449;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy449;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy449;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy449;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy449;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy449:
	++YYCURSOR;
#line 276 "src/scanner.re"
	{
            yylval->charValue = '\n';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10656 "<stdout>"
yy451:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy452;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy452;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy452;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy452;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy452;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy452;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy452:
	++YYCURSOR;
#line 282 "src/scanner.re"
	{
            yylval->charValue = 0x00;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10721 "<stdout>"
yy454:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy458;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy458;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy458;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy458;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy458;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy458;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy458:
	++YYCURSOR;
#line 270 "src/scanner.re"
	{
            yylval->charValue = ' ';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10792 "<stdout>"
yy460:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy514;
		if (yych <= 'H') goto yy46;
		goto yy514;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy514;
		} else {
			if (yych == 'i') goto yy514;
			goto yy46;
		}
	}
yy461:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy502;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy500;
		if (yych == 'n') goto yy501;
		goto yy46;
	}
yy462:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy467;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy467;
					if (yych <= 0x0000001F) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy467;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy465;
					goto yy46;
				} else {
					if (yych <= '-') goto yy465;
					if (yych <= '.') goto yy467;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '1') goto yy462;
					if (yych <= ':') goto yy46;
					goto yy467;
				} else {
					if (yych == '@') goto yy466;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy467;
					goto yy46;
				} else {
					if (yych <= ']') goto yy467;
					if (yych <= 0x00000084) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy467;
					if (yych <= 0x0000180D) goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy467;
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy498;
	goto yy46;
yy465:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy484;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy487;
		if (yych == 'n') goto yy486;
		goto yy46;
	}
yy466:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy469;
		goto yy46;
	} else {
		if (yych <= '-') goto yy469;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy470;
		goto yy46;
	}
yy467:
	++YYCURSOR;
#line 356 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 10942 "<stdout>"
yy469:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '2') goto yy46;
	} else {
		if (yych <= 'i') goto yy476;
		if (yych == 'n') goto yy475;
		goto yy46;
	}
yy470:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy467;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy467;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy467;
					goto yy46;
				} else {
					if (yych <= '#') goto yy467;
					if (yych <= '\'') goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy467;
				} else {
					if (yych <= '/') goto yy472;
					if (yych <= '1') goto yy470;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy467;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy467;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy467;
				if (yych <= 0x0000009F) goto yy46;
				goto yy467;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x0000180E) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy467;
					if (yych <= 0x0000202E) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy472:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy473:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy467;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy467;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy467;
					goto yy46;
				} else {
					if (yych <= '#') goto yy467;
					if (yych <= '\'') goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy467;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '1') goto yy473;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy467;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy467;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy467;
				if (yych <= 0x0000009F) goto yy46;
				goto yy467;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x0000180E) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy467;
					if (yych <= 0x0000202E) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy475:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy481;
	goto yy46;
yy476:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy480:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy467;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy467;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy467;
					goto yy46;
				} else {
					if (yych <= '#') goto yy467;
					if (yych <= '\'') goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy467;
				if (yych <= ':') goto yy46;
				goto yy467;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy467;
				} else {
					if (yych == ']') goto yy467;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy467;
				if (yych == 0x000000A0) goto yy467;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy467;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy467;
				if (yych <= 0x0000202E) goto yy46;
				goto yy467;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy481:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy480;
	goto yy46;
yy484:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '1') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy495;
		goto yy484;
	} else {
		if (yych == 'i') goto yy480;
		goto yy46;
	}
yy486:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy492;
	goto yy46;
yy487:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy467;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy467;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy467;
					goto yy46;
				} else {
					if (yych <= '#') goto yy467;
					if (yych <= '\'') goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy467;
				} else {
					if (yych == ';') goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy467;
					goto yy46;
				} else {
					if (yych <= ']') goto yy467;
					if (yych <= 'm') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy467;
				if (yych <= 0x0000009F) goto yy46;
				goto yy467;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x0000180E) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy467;
					if (yych <= 0x0000202E) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy491:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy480;
	goto yy46;
yy492:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy491;
	goto yy46;
yy495:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy496:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy496;
	if (yych == 'i') goto yy480;
	goto yy46;
yy498:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy467;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy467;
					if (yych <= 0x0000001F) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy467;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy465;
					goto yy46;
				} else {
					if (yych <= '-') goto yy465;
					if (yych <= '.') goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '1') goto yy498;
					if (yych <= ':') goto yy46;
					goto yy467;
				} else {
					if (yych == '@') goto yy466;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy467;
					goto yy46;
				} else {
					if (yych <= ']') goto yy467;
					if (yych <= 0x00000084) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy467;
					if (yych <= 0x0000180D) goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy467;
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy500:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy467;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy467;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy467;
					goto yy46;
				} else {
					if (yych <= '#') goto yy467;
					if (yych <= '\'') goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy467;
				} else {
					if (yych == ';') goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy467;
					goto yy46;
				} else {
					if (yych <= ']') goto yy467;
					if (yych <= 'm') goto yy46;
					goto yy511;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy467;
				if (yych <= 0x0000009F) goto yy46;
				goto yy467;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x0000180E) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy467;
					if (yych <= 0x0000202E) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy501:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy507;
	goto yy46;
yy502:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy467;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy467;
					if (yych <= 0x0000001F) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy467;
					goto yy46;
				} else {
					if (yych <= ')') goto yy467;
					if (yych <= '*') goto yy46;
					goto yy465;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy465;
				} else {
					if (yych <= '.') goto yy467;
					if (yych >= '0') goto yy502;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy467;
					goto yy46;
				} else {
					if (yych <= '@') goto yy466;
					if (yych <= 'Z') goto yy46;
					goto yy467;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy467;
				} else {
					if (yych == 'i') goto yy480;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy467;
					if (yych <= 0x0000009F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00001680) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy467;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy467;
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy505:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy467;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy467;
					if (yych <= 0x0000001F) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy467;
					goto yy46;
				} else {
					if (yych <= ')') goto yy467;
					if (yych <= '*') goto yy46;
					goto yy465;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy465;
				} else {
					if (yych <= '.') goto yy467;
					if (yych <= '/') goto yy46;
					goto yy505;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy467;
					goto yy46;
				} else {
					if (yych <= '@') goto yy466;
					if (yych <= 'Z') goto yy46;
					goto yy467;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy467;
				} else {
					if (yych == 'i') goto yy480;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy467;
					if (yych <= 0x0000009F) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00001680) goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy467;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy467;
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy507:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy510:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy467;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy467;
					if (yych <= 0x0000001F) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy467;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy467;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy465;
					goto yy46;
				} else {
					if (yych <= '-') goto yy465;
					if (yych <= '.') goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy467;
					if (yych <= '?') goto yy46;
					goto yy466;
				} else {
					if (yych == '[') goto yy467;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy467;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy480;
					if (yych <= 0x00000084) goto yy46;
					goto yy467;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy467;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy467;
					if (yych <= 0x0000180D) goto yy46;
					goto yy467;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy467;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy467;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy467;
					if (yych <= 0x0000205E) goto yy46;
					goto yy467;
				} else {
					if (yych == 0x00003000) goto yy467;
					goto yy46;
				}
			}
		}
	}
yy511:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy510;
	goto yy46;
yy514:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy461;
		goto yy46;
	} else {
		if (yych <= '-') goto yy461;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy462;
		goto yy46;
	}
yy515:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy519;
		if (yych <= 'H') goto yy46;
		goto yy519;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy519;
		} else {
			if (yych == 'i') goto yy519;
			goto yy46;
		}
	}
yy516:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy518;
		if (yych <= '/') goto yy46;
		goto yy302;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy300;
		} else {
			if (yych == 'n') goto yy301;
			goto yy46;
		}
	}
yy517:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy74;
	goto yy46;
yy518:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy329;
	goto yy46;
yy519:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy516;
		if (yych <= ',') goto yy46;
		goto yy516;
	} else {
		if (yych <= '.') goto yy517;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy159;
		goto yy46;
	}
yy520:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy574;
		if (yych <= 'H') goto yy46;
		goto yy574;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy574;
		} else {
			if (yych == 'i') goto yy574;
			goto yy46;
		}
	}
yy521:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy562;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy560;
		if (yych == 'n') goto yy561;
		goto yy46;
	}
yy522:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy527;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy527;
					if (yych <= 0x0000001F) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy527;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy525;
					goto yy46;
				} else {
					if (yych <= '-') goto yy525;
					if (yych <= '.') goto yy527;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '7') goto yy522;
					if (yych <= ':') goto yy46;
					goto yy527;
				} else {
					if (yych == '@') goto yy526;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy527;
					goto yy46;
				} else {
					if (yych <= ']') goto yy527;
					if (yych <= 0x00000084) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy527;
					if (yych <= 0x0000180D) goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy527;
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy558;
	goto yy46;
yy525:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy544;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy547;
		if (yych == 'n') goto yy546;
		goto yy46;
	}
yy526:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy529;
		goto yy46;
	} else {
		if (yych <= '-') goto yy529;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy530;
		goto yy46;
	}
yy527:
	++YYCURSOR;
#line 368 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 11983 "<stdout>"
yy529:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '8') goto yy46;
	} else {
		if (yych <= 'i') goto yy536;
		if (yych == 'n') goto yy535;
		goto yy46;
	}
yy530:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy527;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy527;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy527;
					goto yy46;
				} else {
					if (yych <= '#') goto yy527;
					if (yych <= '\'') goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy527;
				} else {
					if (yych <= '/') goto yy532;
					if (yych <= '7') goto yy530;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy527;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy527;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy527;
				if (yych <= 0x0000009F) goto yy46;
				goto yy527;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x0000180E) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy527;
					if (yych <= 0x0000202E) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy532:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy533:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy527;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy527;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy527;
					goto yy46;
				} else {
					if (yych <= '#') goto yy527;
					if (yych <= '\'') goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy527;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '7') goto yy533;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy527;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy527;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy527;
				if (yych <= 0x0000009F) goto yy46;
				goto yy527;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x0000180E) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy527;
					if (yych <= 0x0000202E) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy535:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy541;
	goto yy46;
yy536:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy540:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy527;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy527;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy527;
					goto yy46;
				} else {
					if (yych <= '#') goto yy527;
					if (yych <= '\'') goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy527;
				if (yych <= ':') goto yy46;
				goto yy527;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy527;
				} else {
					if (yych == ']') goto yy527;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy527;
				if (yych == 0x000000A0) goto yy527;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy527;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy527;
				if (yych <= 0x0000202E) goto yy46;
				goto yy527;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy541:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy540;
	goto yy46;
yy544:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '7') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy555;
		goto yy544;
	} else {
		if (yych == 'i') goto yy540;
		goto yy46;
	}
yy546:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy552;
	goto yy46;
yy547:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy527;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy527;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy527;
					goto yy46;
				} else {
					if (yych <= '#') goto yy527;
					if (yych <= '\'') goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy527;
				} else {
					if (yych == ';') goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy527;
					goto yy46;
				} else {
					if (yych <= ']') goto yy527;
					if (yych <= 'm') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy527;
				if (yych <= 0x0000009F) goto yy46;
				goto yy527;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x0000180E) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy527;
					if (yych <= 0x0000202E) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy551:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy540;
	goto yy46;
yy552:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy551;
	goto yy46;
yy555:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy556:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy556;
	if (yych == 'i') goto yy540;
	goto yy46;
yy558:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy527;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy527;
					if (yych <= 0x0000001F) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy527;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy525;
					goto yy46;
				} else {
					if (yych <= '-') goto yy525;
					if (yych <= '.') goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '7') goto yy558;
					if (yych <= ':') goto yy46;
					goto yy527;
				} else {
					if (yych == '@') goto yy526;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy527;
					goto yy46;
				} else {
					if (yych <= ']') goto yy527;
					if (yych <= 0x00000084) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy527;
					if (yych <= 0x0000180D) goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy527;
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy560:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy527;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy527;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy527;
					goto yy46;
				} else {
					if (yych <= '#') goto yy527;
					if (yych <= '\'') goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy527;
				} else {
					if (yych == ';') goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy527;
					goto yy46;
				} else {
					if (yych <= ']') goto yy527;
					if (yych <= 'm') goto yy46;
					goto yy571;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy527;
				if (yych <= 0x0000009F) goto yy46;
				goto yy527;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x0000180E) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy527;
					if (yych <= 0x0000202E) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy561:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy567;
	goto yy46;
yy562:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy527;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy527;
					if (yych <= 0x0000001F) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy527;
					goto yy46;
				} else {
					if (yych <= ')') goto yy527;
					if (yych <= '*') goto yy46;
					goto yy525;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy525;
				} else {
					if (yych <= '.') goto yy527;
					if (yych >= '0') goto yy562;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy527;
					goto yy46;
				} else {
					if (yych <= '@') goto yy526;
					if (yych <= 'Z') goto yy46;
					goto yy527;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy527;
				} else {
					if (yych == 'i') goto yy540;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy527;
					if (yych <= 0x0000009F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00001680) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy527;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy527;
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy565:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy527;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy527;
					if (yych <= 0x0000001F) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy527;
					goto yy46;
				} else {
					if (yych <= ')') goto yy527;
					if (yych <= '*') goto yy46;
					goto yy525;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy525;
				} else {
					if (yych <= '.') goto yy527;
					if (yych <= '/') goto yy46;
					goto yy565;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy527;
					goto yy46;
				} else {
					if (yych <= '@') goto yy526;
					if (yych <= 'Z') goto yy46;
					goto yy527;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy527;
				} else {
					if (yych == 'i') goto yy540;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy527;
					if (yych <= 0x0000009F) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00001680) goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy527;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy527;
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy567:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy570:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy527;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy527;
					if (yych <= 0x0000001F) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy527;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy527;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy525;
					goto yy46;
				} else {
					if (yych <= '-') goto yy525;
					if (yych <= '.') goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy527;
					if (yych <= '?') goto yy46;
					goto yy526;
				} else {
					if (yych == '[') goto yy527;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy527;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy540;
					if (yych <= 0x00000084) goto yy46;
					goto yy527;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy527;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy527;
					if (yych <= 0x0000180D) goto yy46;
					goto yy527;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy527;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy527;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy527;
					if (yych <= 0x0000205E) goto yy46;
					goto yy527;
				} else {
					if (yych == 0x00003000) goto yy527;
					goto yy46;
				}
			}
		}
	}
yy571:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy570;
	goto yy46;
yy574:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy521;
		goto yy46;
	} else {
		if (yych <= '-') goto yy521;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy522;
		goto yy46;
	}
yy575:
	yych = *++YYCURSOR;
	if (yych <= 'X') {
		if (yych <= 'D') {
			if (yych == 'B') goto yy514;
			if (yych <= 'C') goto yy46;
			goto yy519;
		} else {
			if (yych == 'O') goto yy574;
			if (yych <= 'W') goto yy46;
		}
	} else {
		if (yych <= 'd') {
			if (yych == 'b') goto yy514;
			if (yych <= 'c') goto yy46;
			goto yy519;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy46;
				goto yy574;
			} else {
				if (yych != 'x') goto yy46;
			}
		}
	}
yy576:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych != '+') goto yy46;
		} else {
			if (yych <= '-') goto yy577;
			if (yych <= '.') goto yy582;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy578;
			if (yych <= '@') goto yy46;
			goto yy580;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy580;
			goto yy46;
		}
	}
yy577:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy707;
			goto yy46;
		} else {
			if (yych <= '9') goto yy703;
			if (yych <= '@') goto yy46;
			goto yy705;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy705;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy701;
			if (yych == 'n') goto yy702;
			goto yy46;
		}
	}
yy578:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy679;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy676;
					if (yych <= '9') goto yy578;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy680;
					if (yych <= 'K') goto yy46;
					goto yy681;
				} else {
					if (yych == 'S') goto yy681;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= '`') {
					if (yych == ']') goto yy586;
					goto yy46;
				} else {
					if (yych <= 'c') goto yy580;
					if (yych <= 'f') goto yy680;
					if (yych <= 'k') goto yy46;
					goto yy681;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy681;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy586;
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy580:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy586;
				} else {
					if (yych <= '/') goto yy676;
					if (yych <= '9') goto yy580;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				} else {
					if (yych <= 'F') goto yy580;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy580;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy582:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy583:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '+') goto yy589;
					if (yych <= ',') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy583;
				} else {
					if (yych == ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				} else {
					if (yych <= 'L') goto yy585;
					if (yych != 'S') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy586;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy585;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy586;
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy585:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy673;
		goto yy46;
	} else {
		if (yych <= '-') goto yy673;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy674;
		goto yy46;
	}
yy586:
	++YYCURSOR;
yy587:
#line 374 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 13196 "<stdout>"
yy588:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych == '+') goto yy632;
			goto yy46;
		} else {
			if (yych <= '-') goto yy632;
			if (yych <= '.') goto yy637;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy633;
			if (yych <= '@') goto yy46;
			goto yy635;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy635;
			goto yy46;
		}
	}
yy589:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy596;
			goto yy46;
		} else {
			if (yych <= '9') goto yy592;
			if (yych <= '@') goto yy46;
			goto yy594;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy594;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy590;
			if (yych == 'n') goto yy591;
			goto yy46;
		}
	}
yy590:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych == ';') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 'm') goto yy46;
					goto yy629;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy591:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy625;
	goto yy46;
yy592:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'R') {
		if (yych <= '@') {
			if (yych <= '.') {
				if (yych <= '-') goto yy46;
				goto yy607;
			} else {
				if (yych <= '/') goto yy604;
				if (yych <= '9') goto yy592;
				goto yy46;
			}
		} else {
			if (yych <= 'F') {
				if (yych >= 'D') goto yy608;
			} else {
				if (yych == 'L') goto yy609;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') {
				if (yych <= 'S') goto yy609;
				goto yy46;
			} else {
				if (yych <= 'c') goto yy594;
				if (yych <= 'f') goto yy608;
				goto yy46;
			}
		} else {
			if (yych <= 'l') {
				if (yych <= 'i') goto yy600;
				if (yych <= 'k') goto yy46;
				goto yy609;
			} else {
				if (yych == 's') goto yy609;
				goto yy46;
			}
		}
	}
yy594:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy604;
		} else {
			if (yych <= '9') goto yy594;
			if (yych <= '@') goto yy46;
			goto yy594;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy594;
		} else {
			if (yych == 'i') goto yy600;
			goto yy46;
		}
	}
yy596:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy597:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy597;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych == 'L') goto yy599;
			if (yych <= 'R') goto yy46;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy599;
			if (yych <= 'h') goto yy46;
			goto yy600;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
			} else {
				if (yych != 's') goto yy46;
			}
		}
	}
yy599:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy601;
		goto yy46;
	} else {
		if (yych <= '-') goto yy601;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy602;
		goto yy46;
	}
yy600:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy586;
				if (yych <= ':') goto yy46;
				goto yy586;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy586;
				} else {
					if (yych == ']') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy586;
				if (yych == 0x000000A0) goto yy586;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy586;
				if (yych <= 0x0000202E) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy601:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy602:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy602;
	if (yych == 'i') goto yy600;
	goto yy46;
yy604:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy46;
	goto yy606;
yy605:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy606:
	if (yych <= 'F') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy605;
		if (yych <= '@') goto yy46;
		goto yy605;
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy605;
		} else {
			if (yych == 'i') goto yy600;
			goto yy46;
		}
	}
yy607:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy616;
			if (yych <= 'F') goto yy617;
			goto yy616;
		} else {
			if (yych <= 'L') goto yy617;
			if (yych <= 'R') goto yy616;
			goto yy617;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy616;
			if (yych <= 'f') goto yy617;
			goto yy616;
		} else {
			if (yych <= 'l') goto yy617;
			if (yych == 's') goto yy617;
			goto yy616;
		}
	}
yy608:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy610;
	if (yych == '-') goto yy610;
	goto yy614;
yy609:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy610;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy611;
		goto yy46;
	}
yy610:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy611:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy611;
	if (yych == 'i') goto yy600;
	goto yy46;
yy613:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy614:
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy604;
		} else {
			if (yych <= '9') goto yy613;
			if (yych <= '@') goto yy46;
			goto yy594;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy594;
		} else {
			if (yych == 'i') goto yy600;
			goto yy46;
		}
	}
yy615:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy616:
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy615;
			if (yych <= 'C') goto yy46;
			goto yy621;
		} else {
			if (yych == 'L') goto yy621;
			if (yych <= 'R') goto yy46;
			goto yy621;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy621;
			if (yych <= 'h') goto yy46;
			goto yy600;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
				goto yy621;
			} else {
				if (yych == 's') goto yy621;
				goto yy46;
			}
		}
	}
yy617:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy618;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy619;
		goto yy46;
	}
yy618:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy619:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy619;
	if (yych == 'i') goto yy600;
	goto yy46;
yy621:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy622;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy623;
		goto yy46;
	}
yy622:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy623:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy623;
	if (yych == 'i') goto yy600;
	goto yy46;
yy625:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy628:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy600;
	goto yy46;
yy629:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy628;
	goto yy46;
yy632:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy637;
			goto yy46;
		} else {
			if (yych <= '9') goto yy633;
			if (yych <= '@') goto yy46;
			goto yy635;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy635;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy666;
			if (yych == 'n') goto yy665;
			goto yy46;
		}
	}
yy633:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy647;
					if (yych <= '/') goto yy644;
					goto yy633;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '@') {
					if (yych == ';') goto yy586;
					goto yy46;
				} else {
					if (yych <= 'C') goto yy635;
					if (yych <= 'F') goto yy648;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy649;
					if (yych <= 'R') goto yy46;
					goto yy649;
				} else {
					if (yych == '[') goto yy586;
					if (yych <= '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 'r') {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					if (yych >= 'd') goto yy648;
				} else {
					if (yych == 'l') goto yy649;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 's') goto yy649;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x000000A0) goto yy586;
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy635:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy586;
					goto yy644;
				} else {
					if (yych <= '9') goto yy635;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy635;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy635;
				} else {
					if (yych == 0x00000085) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy637:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy638:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '.') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy638;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy640;
					if (yych <= 'R') goto yy46;
				} else {
					if (yych == '[') goto yy586;
					if (yych <= '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych >= 'g') goto yy46;
				} else {
					if (yych <= 'l') goto yy640;
					if (yych <= 'r') goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy586;
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy640:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy641;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy642;
		goto yy46;
	}
yy641:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy642:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy642;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy586;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy644:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy645;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy645:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy586;
					goto yy46;
				} else {
					if (yych <= '9') goto yy645;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy645;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy645;
				} else {
					if (yych == 0x00000085) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy647:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy587;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy587;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy587;
					goto yy586;
				} else {
					if (yych == '.') goto yy586;
					goto yy587;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy655;
					if (yych <= ':') goto yy587;
					goto yy586;
				} else {
					if (yych <= 'C') goto yy587;
					if (yych <= 'F') goto yy657;
					goto yy587;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy657;
					if (yych <= 'R') goto yy587;
					goto yy657;
				} else {
					if (yych == '[') goto yy586;
					if (yych <= '\\') goto yy587;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy587;
					if (yych <= 'f') goto yy657;
					goto yy587;
				} else {
					if (yych <= 'l') goto yy657;
					if (yych <= 'r') goto yy587;
					goto yy657;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy586;
					goto yy587;
				} else {
					if (yych <= 0x000000A0) goto yy586;
					if (yych <= 0x0000167F) goto yy587;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy586;
					goto yy587;
				} else {
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy587;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy587;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy587;
				}
			}
		}
	}
yy648:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy650;
	if (yych == '-') goto yy650;
	goto yy654;
yy649:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy650;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy651;
		goto yy46;
	}
yy650:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy651:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy651;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy586;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy653:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy654:
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy586;
					goto yy644;
				} else {
					if (yych <= '9') goto yy653;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy635;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy635;
				} else {
					if (yych == 0x00000085) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy655:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '.') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy655;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy661;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy661;
					if (yych <= 'R') goto yy46;
					goto yy661;
				} else {
					if (yych == '[') goto yy586;
					if (yych <= '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy661;
					goto yy46;
				} else {
					if (yych <= 'l') goto yy661;
					if (yych <= 'r') goto yy46;
					goto yy661;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy586;
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy657:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy658;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy659;
		goto yy46;
	}
yy658:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy659:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy659;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy586;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy661:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy662;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy663;
		goto yy46;
	}
yy662:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy663:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy663;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy586;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy665:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy670;
	goto yy46;
yy666:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy600;
	goto yy46;
yy670:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy600;
	goto yy46;
yy673:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy674:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy589;
					goto yy46;
				} else {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy674;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych == '@') goto yy588;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy676:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy677;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy677:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy586;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy677;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				} else {
					if (yych <= 'F') goto yy677;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy677;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy679:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy692;
					if (yych <= 0x00000008) goto yy587;
					goto yy692;
				} else {
					if (yych == ' ') goto yy692;
					goto yy587;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy692;
					if (yych <= '\'') goto yy587;
					goto yy692;
				} else {
					if (yych == '+') goto yy692;
					if (yych <= ',') goto yy587;
					goto yy692;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy587;
					if (yych <= '9') goto yy692;
					goto yy587;
				} else {
					if (yych <= ';') goto yy692;
					if (yych == '@') goto yy692;
					goto yy587;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy693;
					if (yych <= 'K') goto yy587;
					goto yy693;
				} else {
					if (yych == 'S') goto yy693;
					if (yych <= 'Z') goto yy587;
					goto yy692;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'c') {
					if (yych == ']') goto yy692;
					goto yy587;
				} else {
					if (yych <= 'f') goto yy693;
					if (yych <= 'k') goto yy587;
					goto yy693;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy693;
					goto yy587;
				} else {
					if (yych <= 0x00000085) goto yy692;
					if (yych == 0x000000A0) goto yy692;
					goto yy587;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy692;
					if (yych <= 0x0000180D) goto yy587;
					goto yy692;
				} else {
					if (yych <= 0x00001FFF) goto yy587;
					if (yych <= 0x0000200A) goto yy692;
					if (yych <= 0x00002027) goto yy587;
					goto yy692;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy692;
					goto yy587;
				} else {
					if (yych <= 0x0000205F) goto yy692;
					if (yych == 0x00003000) goto yy692;
					goto yy587;
				}
			}
		}
	}
yy680:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy687;
	if (yych == '-') goto yy687;
	goto yy686;
yy681:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy682;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy683;
		goto yy46;
	}
yy682:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy683:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy589;
					goto yy46;
				} else {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy683;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych == '@') goto yy588;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy685:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy686:
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy586;
				} else {
					if (yych <= '/') goto yy676;
					if (yych <= '9') goto yy685;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				} else {
					if (yych <= 'F') goto yy580;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy580;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy687:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy596;
			goto yy46;
		} else {
			if (yych <= '9') goto yy688;
			if (yych <= '@') goto yy46;
			goto yy594;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy594;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy590;
			if (yych == 'n') goto yy591;
			goto yy46;
		}
	}
yy688:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy604;
					if (yych <= '9') goto yy688;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
					goto yy594;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy608;
					if (yych == 'L') goto yy609;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy609;
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
					goto yy594;
				} else {
					if (yych <= 'f') goto yy608;
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy609;
					if (yych <= 'r') goto yy46;
					goto yy609;
				} else {
					if (yych == 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy586;
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy690:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy587;
			if (yych <= '9') goto yy615;
			if (yych <= 'C') goto yy587;
			goto yy617;
		} else {
			if (yych == 'L') goto yy617;
			if (yych <= 'R') goto yy587;
			goto yy617;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy587;
			if (yych <= 'f') goto yy617;
			if (yych <= 'h') goto yy587;
			goto yy600;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy587;
				goto yy617;
			} else {
				if (yych == 's') goto yy617;
				goto yy587;
			}
		}
	}
yy691:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy692:
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '+') goto yy589;
					if (yych <= ',') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy691;
				} else {
					if (yych == ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy697;
					goto yy46;
				} else {
					if (yych <= 'L') goto yy697;
					if (yych == 'S') goto yy697;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy586;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy697;
					if (yych <= 'k') goto yy46;
					goto yy697;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy697;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy586;
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					if (yych <= 0x00002027) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy693:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy694;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy695;
		goto yy46;
	}
yy694:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy695:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy589;
					goto yy46;
				} else {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy695;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych == '@') goto yy588;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy697:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy698;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy699;
		goto yy46;
	}
yy698:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy699:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy589;
					goto yy46;
				} else {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy699;
					if (yych <= ':') goto yy46;
					goto yy586;
				} else {
					if (yych == '@') goto yy588;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy701:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy586;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy586;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy586;
					goto yy46;
				} else {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy586;
				} else {
					if (yych == ';') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy586;
					goto yy46;
				} else {
					if (yych <= ']') goto yy586;
					if (yych <= 'm') goto yy46;
					goto yy742;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy586;
				if (yych <= 0x0000009F) goto yy46;
				goto yy586;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x0000180E) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy586;
					if (yych <= 0x0000202E) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy702:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy738;
	goto yy46;
yy703:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy717;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy714;
					if (yych <= '9') goto yy703;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy718;
					if (yych == 'L') goto yy719;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy719;
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
				} else {
					if (yych <= 'f') goto yy718;
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy719;
					if (yych <= 'r') goto yy46;
					goto yy719;
				} else {
					if (yych == 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy586;
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy705:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '+') goto yy589;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy714;
				} else {
					if (yych <= '9') goto yy705;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
					goto yy705;
				} else {
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
					goto yy705;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy707:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy708:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy586;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy708;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych == '@') goto yy588;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy710;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy710;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy586;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy710;
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy710;
					if (yych <= 'r') goto yy46;
				} else {
					if (yych == 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy586;
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy710:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy711;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy712;
		goto yy46;
	}
yy711:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy712:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy589;
				} else {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy712;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy586;
					goto yy46;
				} else {
					if (yych <= '@') goto yy588;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy714:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy715;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy715:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '+') goto yy589;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				} else {
					if (yych <= '9') goto yy715;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
					goto yy715;
				} else {
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
					goto yy715;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy717:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy729;
					if (yych <= 0x00000008) goto yy587;
					goto yy729;
				} else {
					if (yych == ' ') goto yy729;
					if (yych <= '!') goto yy587;
					goto yy729;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy587;
					if (yych <= ')') goto yy729;
					goto yy587;
				} else {
					if (yych == ',') goto yy587;
					if (yych <= '.') goto yy729;
					goto yy587;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych == ':') goto yy587;
					goto yy729;
				} else {
					if (yych == '@') goto yy729;
					if (yych <= 'C') goto yy587;
					goto yy730;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy730;
					goto yy587;
				} else {
					if (yych <= 'S') goto yy730;
					if (yych == '[') goto yy729;
					goto yy587;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy729;
					if (yych <= 'c') goto yy587;
					goto yy730;
				} else {
					if (yych == 'i') goto yy729;
					if (yych <= 'k') goto yy587;
					goto yy730;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy730;
					goto yy587;
				} else {
					if (yych <= 0x00000085) goto yy729;
					if (yych == 0x000000A0) goto yy729;
					goto yy587;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy729;
					if (yych <= 0x0000180D) goto yy587;
					goto yy729;
				} else {
					if (yych <= 0x00001FFF) goto yy587;
					if (yych <= 0x0000200A) goto yy729;
					if (yych <= 0x00002027) goto yy587;
					goto yy729;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy729;
					goto yy587;
				} else {
					if (yych <= 0x0000205F) goto yy729;
					if (yych == 0x00003000) goto yy729;
					goto yy587;
				}
			}
		}
	}
yy718:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy725;
	if (yych == '-') goto yy725;
	goto yy724;
yy719:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy720;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy721;
		goto yy46;
	}
yy720:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy721:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy589;
				} else {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy721;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy586;
					goto yy46;
				} else {
					if (yych <= '@') goto yy588;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy723:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy724:
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy586;
					if (yych <= '\'') goto yy46;
					goto yy586;
				} else {
					if (yych == '+') goto yy589;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy714;
				} else {
					if (yych <= '9') goto yy723;
					if (yych <= ':') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
					goto yy705;
				} else {
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
					goto yy705;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy725:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy596;
			goto yy46;
		} else {
			if (yych <= '9') goto yy726;
			if (yych <= '@') goto yy46;
			goto yy594;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy594;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy590;
			if (yych == 'n') goto yy591;
			goto yy46;
		}
	}
yy726:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy690;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy604;
					if (yych <= '9') goto yy726;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy588;
					goto yy594;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy608;
					if (yych == 'L') goto yy609;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy609;
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy586;
					if (yych <= '`') goto yy46;
					goto yy594;
				} else {
					if (yych <= 'f') goto yy608;
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy609;
					if (yych <= 'r') goto yy46;
					goto yy609;
				} else {
					if (yych == 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy586;
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy728:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy729:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy586;
					if (yych <= 0x00000008) goto yy46;
					goto yy586;
				} else {
					if (yych == ' ') goto yy586;
					if (yych <= '!') goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy589;
					goto yy586;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy728;
					goto yy46;
				} else {
					if (yych <= ';') goto yy586;
					if (yych == '@') goto yy588;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy734;
					if (yych <= 'K') goto yy46;
					goto yy734;
				} else {
					if (yych == 'S') goto yy734;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy586;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy734;
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy734;
					if (yych <= 'r') goto yy46;
					goto yy734;
				} else {
					if (yych == 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy586;
					if (yych == 0x0000202F) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy586;
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy730:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy731;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy732;
		goto yy46;
	}
yy731:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy732:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy589;
				} else {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy732;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy586;
					goto yy46;
				} else {
					if (yych <= '@') goto yy588;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy734:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy735;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy736;
		goto yy46;
	}
yy735:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy736:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy586;
					goto yy46;
				} else {
					if (yych <= ')') goto yy586;
					if (yych <= '*') goto yy46;
					goto yy589;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy589;
				} else {
					if (yych <= '.') goto yy586;
					if (yych <= '/') goto yy46;
					goto yy736;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy586;
					goto yy46;
				} else {
					if (yych <= '@') goto yy588;
					if (yych <= 'Z') goto yy46;
					goto yy586;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy586;
				} else {
					if (yych == 'i') goto yy600;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy586;
					if (yych <= 0x0000009F) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00001680) goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy586;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy738:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy741:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy586;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy586;
					if (yych <= 0x0000001F) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy586;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy586;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy589;
					goto yy46;
				} else {
					if (yych <= '-') goto yy589;
					if (yych <= '.') goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy586;
					if (yych <= '?') goto yy46;
					goto yy588;
				} else {
					if (yych == '[') goto yy586;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy586;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy600;
					if (yych <= 0x00000084) goto yy46;
					goto yy586;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy586;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy586;
					if (yych <= 0x0000180D) goto yy46;
					goto yy586;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy586;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy586;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy586;
					if (yych <= 0x0000205E) goto yy46;
					goto yy586;
				} else {
					if (yych == 0x00003000) goto yy586;
					goto yy46;
				}
			}
		}
	}
yy742:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy741;
	goto yy46;
yy745:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy576;
		if (yych <= 'H') goto yy46;
		goto yy576;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy576;
		} else {
			if (yych == 'i') goto yy576;
			goto yy46;
		}
	}
yy746:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '/') goto yy751;
	if (yych == '\\') goto yy746;
	goto yy346;
yy748:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy749;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy749;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy749;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy749;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy749;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy749;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy749:
	++YYCURSOR;
yy750:
#line 386 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN + 2, (YYCURSOR - YYTOKEN) - 3);
            YYTOKEN = YYCURSOR;
            return REGEXP;
        }
#line 17171 "<stdout>"
yy751:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy752;
				if (yych <= 0x00000008) goto yy346;
				if (yych >= 0x0000000E) goto yy346;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy346;
				} else {
					if (yych <= '#') goto yy752;
					if (yych <= '\'') goto yy346;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') goto yy346;
				if (yych <= '.') goto yy752;
				if (yych <= '/') goto yy748;
				goto yy346;
			} else {
				if (yych <= 'Z') {
					if (yych >= '<') goto yy346;
				} else {
					if (yych == '\\') goto yy746;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy752;
				if (yych <= 0x0000009F) goto yy346;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy346;
				} else {
					if (yych != 0x0000180E) goto yy346;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych >= 0x0000200B) goto yy346;
				} else {
					if (yych <= 0x00002029) goto yy752;
					if (yych <= 0x0000202E) goto yy346;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy346;
				} else {
					if (yych != 0x00003000) goto yy346;
				}
			}
		}
	}
yy752:
	yyaccept = 7;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy748;
	if (yych == '\\') goto yy746;
	goto yy346;
yy753:
	++YYCURSOR;
#line 423 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_SYNTAX; }
#line 17248 "<stdout>"
yy755:
	++YYCURSOR;
#line 427 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASISYNTAX; }
#line 17256 "<stdout>"
yy757:
	++YYCURSOR;
#line 431 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAX;
        }
#line 17265 "<stdout>"
yy759:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 436 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAXSPLICING;
        }
#line 17275 "<stdout>"
yy762:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy763:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy768;
			goto yy762;
		} else {
			if (yych <= '\n') goto yy768;
			if (yych <= '\f') goto yy762;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy762;
			goto yy767;
		} else {
			if (yych == 0x00002028) goto yy767;
			goto yy762;
		}
	}
yy764:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy771;
					goto yy762;
				} else {
					if (yych == '\n') goto yy771;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy773;
					goto yy762;
				} else {
					if (yych == '!') goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy762;
					goto yy772;
				} else {
					if (yych == '.') goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy772;
					goto yy762;
				} else {
					if (yych == '\\') goto yy762;
					goto yy772;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy762;
					goto yy775;
				} else {
					if (yych == 0x000000A0) goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy772;
					goto yy762;
				} else {
					if (yych <= 0x0000180E) goto yy772;
					if (yych <= 0x00001FFF) goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy762;
					goto yy775;
				} else {
					if (yych <= 0x00002029) goto yy772;
					if (yych <= 0x0000202E) goto yy762;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy762;
					goto yy772;
				} else {
					if (yych == 0x00003000) goto yy772;
					goto yy762;
				}
			}
		}
	}
yy765:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\f') {
			if (yych <= 0x00000000) goto yy768;
			if (yych == '\n') goto yy768;
			goto yy762;
		} else {
			if (yych <= ',') {
				if (yych <= '\r') goto yy764;
				goto yy762;
			} else {
				if (yych <= '9') goto yy765;
				if (yych <= '@') goto yy762;
				goto yy765;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych == '_') goto yy765;
			if (yych <= '`') goto yy762;
			goto yy765;
		} else {
			if (yych <= 0x00000085) {
				if (yych <= 0x00000084) goto yy762;
			} else {
				if (yych != 0x00002028) goto yy762;
			}
		}
	}
yy767:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy771;
					goto yy762;
				} else {
					if (yych == '\n') goto yy771;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy773;
					goto yy762;
				} else {
					if (yych == '!') goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy762;
					goto yy772;
				} else {
					if (yych == '.') goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy772;
					goto yy762;
				} else {
					if (yych == '\\') goto yy762;
					goto yy772;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy762;
					goto yy775;
				} else {
					if (yych == 0x000000A0) goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy772;
					goto yy762;
				} else {
					if (yych <= 0x0000180E) goto yy772;
					if (yych <= 0x00001FFF) goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy762;
					goto yy775;
				} else {
					if (yych <= 0x00002029) goto yy772;
					if (yych <= 0x0000202E) goto yy762;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy762;
					goto yy772;
				} else {
					if (yych == 0x00003000) goto yy772;
					goto yy762;
				}
			}
		}
	}
yy768:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy769;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy769;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy769;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy769;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy769;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy769;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy769:
	++YYCURSOR;
yy770:
#line 235 "src/scanner.re"
	{
            YYCURSOR--;
            ucs4string shebang(YYTOKEN, YYCURSOR - YYTOKEN - 1);
            if (shebang == ucs4string(UC("#!r6rs"))) {
                currentVM()->readerContext()->port()->setStrictR6RsReaderMode();
            } else {
                 // just ignore the shebang.
            }
            YYTOKEN = YYCURSOR;
            continue;
       }
#line 17567 "<stdout>"
yy771:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy769;
				if (yych <= 0x00000008) goto yy770;
				if (yych <= '\r') goto yy769;
				goto yy770;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy769;
					goto yy770;
				} else {
					if (yych <= '#') goto yy769;
					if (yych <= '\'') goto yy770;
					goto yy769;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy769;
				if (yych <= ':') goto yy770;
				goto yy769;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy770;
					goto yy769;
				} else {
					if (yych == ']') goto yy769;
					goto yy770;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy769;
				if (yych == 0x000000A0) goto yy769;
				goto yy770;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy769;
					goto yy770;
				} else {
					if (yych <= 0x0000180E) goto yy769;
					if (yych <= 0x00001FFF) goto yy770;
					goto yy769;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy770;
				if (yych <= 0x00002029) goto yy769;
				if (yych <= 0x0000202E) goto yy770;
				goto yy769;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy770;
					goto yy769;
				} else {
					if (yych == 0x00003000) goto yy769;
					goto yy770;
				}
			}
		}
	}
yy772:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy768;
			goto yy762;
		} else {
			if (yych <= '\n') goto yy768;
			if (yych <= '\f') goto yy762;
			goto yy764;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy762;
			goto yy767;
		} else {
			if (yych == 0x00002028) goto yy767;
			goto yy762;
		}
	}
yy773:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy771;
					goto yy762;
				} else {
					if (yych == '\n') goto yy771;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy773;
					goto yy762;
				} else {
					if (yych == '!') goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy762;
					goto yy772;
				} else {
					if (yych == '.') goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy772;
					goto yy762;
				} else {
					if (yych == '\\') goto yy762;
					goto yy772;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy762;
				} else {
					if (yych == 0x000000A0) goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy772;
					goto yy762;
				} else {
					if (yych <= 0x0000180E) goto yy772;
					if (yych <= 0x00001FFF) goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy762;
				} else {
					if (yych <= 0x00002029) goto yy772;
					if (yych <= 0x0000202E) goto yy762;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy762;
					goto yy772;
				} else {
					if (yych == 0x00003000) goto yy772;
					goto yy762;
				}
			}
		}
	}
yy775:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy771;
					goto yy762;
				} else {
					if (yych == '\n') goto yy771;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy773;
					goto yy762;
				} else {
					if (yych == '!') goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy762;
					goto yy772;
				} else {
					if (yych == '.') goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy772;
					goto yy762;
				} else {
					if (yych == '\\') goto yy762;
					goto yy772;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy762;
					goto yy775;
				} else {
					if (yych == 0x000000A0) goto yy772;
					goto yy762;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy772;
					goto yy762;
				} else {
					if (yych <= 0x0000180E) goto yy772;
					if (yych <= 0x00001FFF) goto yy762;
					goto yy772;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy762;
					goto yy775;
				} else {
					if (yych <= 0x00002029) goto yy772;
					if (yych <= 0x0000202E) goto yy762;
					goto yy772;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy762;
					goto yy772;
				} else {
					if (yych == 0x00003000) goto yy772;
					goto yy762;
				}
			}
		}
	}
yy777:
	yych = *++YYCURSOR;
	if (yych != '8') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '(') goto yy46;
	++YYCURSOR;
#line 459 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return BYTE_VECTOR_START;
        }
#line 17835 "<stdout>"
}
#line 484 "src/scanner.re"


comment:
        YYTOKEN = YYCURSOR;

#line 17843 "<stdout>"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '#') {
		if (yych <= 0x00000000) goto yy786;
		if (yych <= '"') goto yy788;
		goto yy785;
	} else {
		if (yych != '|') goto yy788;
	}
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '#') goto yy791;
yy784:
#line 506 "src/scanner.re"
	{
            goto comment;
        }
#line 17862 "<stdout>"
yy785:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy789;
	goto yy784;
yy786:
	++YYCURSOR;
#line 501 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return 0;
        }
#line 17874 "<stdout>"
yy788:
	yych = *++YYCURSOR;
	goto yy784;
yy789:
	++YYCURSOR;
#line 497 "src/scanner.re"
	{
            comment_count++;
            goto comment;
        }
#line 17885 "<stdout>"
yy791:
	++YYCURSOR;
#line 489 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            if (--comment_count == 0) {
                continue;
            } else {
                goto comment;
            }
        }
#line 17897 "<stdout>"
}
#line 509 "src/scanner.re"

    }
}

ucs4string Scanner::currentToken() const
{
    if (limit_ >= token_) {
        return ucs4string(token_, limit_ - token_);
    } else {
        return ucs4string(UC(""));
    }
}
